define(['jquery', 'virtual-dom/h', 'vdom-virtualize', 'render-tree', 'theme-ecmwf-2017/bootstrap/dropdown'], function($, h, virtualise, RenderTree) {

	function AppMenu(options) {

		var el = options.el
		var items = options.items
		var help = options.help

		function item(menu, item) {
			return item.title
				? h('li', [
					h('a', {
						href: (item.href || ('#' + item.name)),
						onclick: item.href ? undefined : function(e) {
							item.selected ? item.selected() : Bus().send(['menu', menu.name, item.name, 'select'].join('-'));
							e.preventDefault();
						}
					}, [item.title])
				])
				: h('li.divider')
		}

		var a = new RenderTree({
			root: el[0],
			tree: virtualise(el[0]),
			main: {
				render: function() {
					if(!__FOUNDATION__){
						return h('.row', [
							h('.col-xs-9.col-sm-9', [
								h('ul#main-menu', $.map(items, function(menu){
									if(menu.enabled === false) return;
									return h('li', [
										h('.btn-group', [
											h( 'a.btn.btn-link.dropdown-toggle',
												(menu.items ? {type: 'button', attributes: {'data-toggle': 'dropdown'}} : {href: menu.href/*, onclick: function(){ console.log('click') }*/}),
												[menu.title, h('span' + (menu.items ? '.caret' : ''))]
											),
											h('ul.dropdown-menu.dropdown-menu-small', $.map(menu.items, function(v) { return item(menu, v) }))
										])
									])
								}))
							]),
							h('.col-xs-3.col-sm-3.text-right-xs.text-right-sm.text-right-md.text-right-lg', [
								h('ul#help-menu', $.map(help, function(menu){
									return h('li', [
										h('.btn-group', [
											h('a.btn.btn-link.dropdown-toggle', {type: 'button', attributes: {'data-toggle': 'dropdown'}}, [menu.title, h('span.caret')]),
											h('ul.dropdown-menu.pull-right', $.map(menu.items, function(v) { return item(menu, v) }))
										])
									])
								}))
							])
						])
					}
				}
			}
		})

		return a
	}
	return AppMenu
})
