/*
 *  A widget to catch mouse clicks outside of the host widget. Useful for popup windows.
 *  If clicked upon, it will destroy itself and notify the host.
 */
define(['jquery', 'jquery-ui/widget'], function($) {

$.widget('ui.backgroundMask', {
	options: {
		on_click: function(){}
	},

	_init: function() {
		var self = this, o = this.options;

		if($('#background-mask').length) console.warn('already exists.');

		var z_index = parseInt(this.element.css('z-index'), 10)
		if(isNaN(z_index) || (z_index < 1051)) this.element.css({zIndex: 1051});

		this.mask = $('body').div({id: 'background-mask', css: {position:'absolute', width:'100%', top:0, bottom:0, zIndex: 1050}})
			.click(function(){
				o.on_click();
				self.destroy();
				return false;
			});
	},

	destroy: function(){
		this.mask.remove();
		return this;
	}
});

});
