
define(['jquery', 'ajax_queue', 'basic_chart/mixins', 'basic_chart/model/product'], function($, Ajaxqueue, mixins, BasicInstance){

	var instances;
	return instances || (instances = new (function BasicInstances(){

		this.fetch = function(pkg, on_success){
			if(!on_success && $.isFunction(pkg)){ on_success = pkg; pkg = null; }
			console.log('instances.fetch');

			this.fetch_lite(pkg, function(list){
				on_success($.map(list, function(item){ return new BasicInstance.Instance(item); }));
			});
		}

		this.fetch_lite = function(pkg, on_success){
			var self = this;
			if(!on_success && $.isFunction(pkg)){ on_success = pkg; pkg = null; }

			AjaxQueue({
				url        : '/plots/get-instance-list/',
				data       : JSON.stringify({'package': (pkg || '')}),
				priority   : 'very-high',
				success    : function (result) {
					var products = $.map(result.records, function(item){
						if(self.validate([
								['has name', function(){ return item.name; }]
								//['has title', function(){ return product.title; }]
							])){

							(function conform(){
								//product.keywords = (product.keys || '').replace(' ', ', ');
								delete item.keys;
								item.title || (item.title = 'Untitled');
							})();

							return item;
						}
					});

					on_success(self.list = $(products));
				}
			});
		}

		/*
		 *  Added for compatibility with grid/products
		 */
		this.facets = function(){
			if(!this._facets){
				this._facets = {};
			}

			return this._facets;
		}

		$.extend(this, mixins);
	})());
});
