/*
 *  Parameter control for parameters of type 'animate'
 */
define('basic_chart/parameter_controls/animate', ['jquery', 'basic_chart/parameter_controls/control'], function($){
	var instance = 0;

	$.widget('ui.parameterAnimate', $.ui.parameterControl, {

		_make_html: function() {
			var self = this, o = self.options;
			self.element.empty();

			self.select = self.element
				.formSelect({
					id: 'parameter-select-' + (++instance),
					options: $.map(o.parameter.values, function(p, i){ return o.parameter.labels ? [[p, o.parameter.labels[i]]] : p; }),
					label: o.parameter.title
				})
				.change(function(ev){
					o.on_select($(this).val());
				});

			self.element.div('<').button().click(function() {
				step(-1);
			});

			self.element.div('PLAY').button().click(function() {
				o.bus.send('toggle-parameter-animate', o.parameter);
			});

			self.element.div('>').button().click(function() {
				step(+1);
			});

			function step(delta) {
				var index = $.inArray(self.select.val(), o.parameter.values) + delta;
				if(index > -1 && index < o.parameter.values.length){
					var value = o.parameter.values[index];
					self.select.val(value);
					o.on_select(value);
				}
			}
		},

		_on_content_update: function() {
			this.select.val(this._value);
		}
	});
});
