
define(['jquery', 'time', './select'], function($, Time){

	$.widget('ui.parameterTime', $.ui.parameterSelect, {

		_name: 'base_time',

		_make_html: function() {
			var self = this, o = self.options, p = o.parameter;

			if(document.contains/* msie */ && !document.contains(self.element[0])) return; // dont allow unparented items because they will not be destroyed

			self.element.empty();
			self.element.removeAttr('id'); // TODO id of time-navigator clashes with the TimeNagivator widget

			if(!p.availability) return;

			// the step and base_time of these Times will be ignored.
			p.labels = [];
			p.values = [];

			var value = -1;
			$.each(p.availability, function(i, v) {
				var str = v.base_time.format(p.format || 'ddd dd mmm yyyy HH "UTC"');
				if(!~$.inArray(str, p.labels)){
					p.values.unshift(i);
					p.labels.unshift(str);
					if(p.value.base_time.value === v.base_time.value) value = i;
				}
			});
			if(value < 0) console.error('value not found');

			if(p.values.length > 1){
				self.menu = self.element.div().chartParameterMenu({
					name: self._name,
					title: 'Base time',
					value: value,
					values: p.values,
					labels: p.labels,
					menu_items: self.bind(self._make_menu_items),
					select: self.bind(self.select_by_value),
					on_click: function(event, ui, parameter) {
						var val = ui.item.value || ui.item.attr('data-value');
						if(p.availability[val]){
							var time = new Time(p.availability[val].base_time, p.value.step, p.value.valid_time);
							o.on_select(p.find_time_by_base_time(time));
						}
					}
				}).chartParameterMenu('instance');
			}
			this._on_content_update();
		},

		select_by_value: function() {
			var self = this, o = self.options, p = o.parameter;

			var index = $.map(p.availability, function(v, i){
				if(v.base_time.getTime() === p.value.base_time.getTime()) return i;
			})[0];

			setTimeout(function() { // menu gets destroyed - wait for new menu
				self.menu.select(self.menu.menu.menu.find('li:eq(' + index + ')'));
			}, 100);
		},

		_on_parameter_change: function() {
			var self = this, o = self.options, p = o.parameter;

			if(p.availability_changed){
				self._make_html();
			}

			this.select_by_value(o.parameter.value)
		},

		_make_menu_items: function() {
			var o = this.options, p = o.parameter;
			return this.menu_items = $.map(p.values, function(a, i){ return '<li data-value="' + a + '"><a href="#" >' + (p.labels[i] || a) + '</a>' + (i ? '' : '<span class="ui-icon ui-icon-check"/>') + '</li>'});
		}
	});
});
