define(['config', 'jquery', './choice', './select', './animate', './multi', './base_time', './weekly', 'utils'], function(ECMWF, $) {

$.fn.controlFactory = function(options) {

	var param = options.parameter[0];

	/*
	 * This is a temporary hack to fix incorrect products.
	 * - 'menu=true' needs to be added to the product definition.
	 */
	if (param.type == 'choice' && param.multi !== true) param.menu = true;

	// note 'menu' is a property not a type
	var T = param.menu
		? 'select'
		: (param.multi
			? 'multi'
			: param.type);

	// in order of preference: override, by name, fallback
	var control = 'parameter' + ECMWF.ucfirst(
		map[T]
			? map[T]
			: ($.fn['parameter' + ECMWF.ucfirst(T)]
				? T
				: 'choice')
	);

	return this.each(function(){
		$(this)[control](options);
	});
}

/*
 *  Parameter control factory for use with BasicInstance objects
 *  (if product objects are standardised it can be used everywhere)
 */
$.fn.basicControlFactory = function(options) {
	options.parameter = [options.parameter]; // pass as array to prevent cloning
	var on_select = options.on_select || $.noop;

	// instance can be a single instance or an array
	var instances = ECMWF.remove(options, 'instance');
	if(!Array.isArray(instances)) instances = [instances]
	var param = options.parameter[0];

	$.extend(options, {
		on_select: function(val){
			console.log('basicControl.on_select: value=', val);
			$.each(instances, function(i, instance){ instance.set_parameter(param.name, val); })
			on_select(val);
		}
	});

	return this.each(function(){
		$(this).controlFactory(options);
		__DEV__ && console.assert(Array.isArray(options.parameter), 'expected parameter is array');
		options.parameter = options.parameter[0];
	});
}

var map = {retention: 'select'};

});
