
define(['jquery', './control'], function($){

	$.widget('ui.parameterMulti', $.ui.parameterControl, {

		_make_html: function() {
			var self = this, o = self.options;
			self.element.empty();

			self.element.span(o.parameter.title);

			$.each(o.parameter.values, function(i, v){
				self.element
					.checkbox({value: v, label: o.parameter.labels ? o.parameter.labels[i] : v})
					.change(function(ev){
						o.on_select($.map(self.element.find(':checked'), function(v){ return $(v).val(); }));
					});
			});
		},

		_on_content_update: function() {
			var self = this;

			var val = this._value;
			if (typeof this._value === 'string') {
				val = [this._value];
			}
			$.each(val, function (i, value) {
				self.element.find('input[value=' + value + ']').prop({checked: true});
			});
		}
	});
});
