
define(['jquery', './control', './widgets/menu'], function($){

	$.widget('ui.parameterSelect', $.ui.parameterControl, {

		_make_html: function() {
			var self = this, o = self.options;

			if(document.contains/* !msie */ && !document.contains(self.element[0])) return; // dont allow unparented items because they will not be destroyed

			self.element.empty();

			self.menu = self.element.div().chartParameterMenu($.extend({
					menu_items: self.bind(self._make_menu_items),
					on_click: function(event, ui, parameter) {
						var value = ui.item.value || ui.item.attr('data-value');
						console.log('parameterSelect.on_click:', value);
						o.on_select(value);
					}
				},
				o.parameter))
				.chartParameterMenu('instance')
		},

		_on_content_update: function(changed) {
			var parameter = this.options.parameter
			if(changed && changed.get('parameters')){
				this.setItems(this.options.parameter);
			}
			var val = parameter.value;

			if(parameter.name === 'time'){
				val = $.map(parameter.availability, function(v, i){
					if(v.base_time.getTime() === parameter.value.base_time.getTime()) return i;
				})[0];
			}

			if(this.menu){
				this.menu.select_by_value(val)
			}
		}
	});
});
