/*
 *  A parameter menu with one row per month
 */
define(['jquery', 'bus', 'jquery-ui/widget'], function($, Bus){

	$.widget('ui.parameterWeekly', $.ui.parameterTime, {

		_name: 'base_time-weekly',

		_make_menu_items: function() {
			var o = this.options, p = o.parameter;

			return $.map(p.by_month(), function(v){
				var s = p.labels[v[0]].split(' ');
				return '<li class="weekly ui-state-disabled">' +
					'<div>' + s[3] + '</div>' +
					'<div class="month">' + s[2] + '</div>' +
					'</li>' +
					$.map(v, function(w, j){
						var s = p.labels[w].split(' ');
						var selected = p.availability[p.values[w]].base_time.getTime() === p.value.base_time.getTime();
						return '<li data-value="' + p.values[w] + '" class="weekly' + (selected ? ' selected' : '') + '"><a href="#">' + s[1] + '</a></li>';
					}).join('');
			});
		},

		_on_parameter_change: function() {
			var self = this, o = self.options, p = o.parameter;

			if(p.availability_changed){
				self._make_html();
			}

			self.menu.find('.selected').removeClass('selected');
			self.menu.find("[data-value='" + p.index() + "']").addClass('selected');
		}
	});
});
