/*
 *  basic_chart/parameter_select
 *
 *  This chart mixin creates a menu bar for parameter selection.
 *
 *  ** This uses the Select widget and not the Menu widget as in the original version.
 */
define(['jquery', 'bus', './parameter_controls/factory', 'basic_chart/parameter_select.css'], function($, Bus) {

	return function(chart, o) {

		o.controls.addClass('chart-parameter-bar');

		chart.bus.listen('product-swapped', function() {
			o.controls.find('> *').not('.keep').remove();
		});

		chart.bus.listen('product-swapped-and-loaded', function(msg) {

			if(o.controls.find('> div').not('.keep').length) return __DEV__ && console.warn('cannot create parameter menu, container not empty');

			if($.isEmptyObject(chart.instance.variables)){
				o.controls.p().text('No modifiable parameters');
			}else{
				$.each(chart.instance.variables, function(i, param) {
					o.controls.div('#' + param.name + '-navigator')
						.basicControlFactory({
							parameter: param,
							instance: chart.instance,
							bus: chart.bus,
							on_select: function(val){
								console.log('catalogue2.basic.control.on_select: ', val);
								Bus().send('add-page-state');
							}
						});

					typeof param === 'choice' && console.warn('parameter_menu: parameter-type choice not handled');
				});
			}
			o.controls.show();
		});

		$('body').off('click', close).click(close);

		this.destroy = function() {
											chart.bus.forget(this); // not needed. chart is destroyed so should not emit messages.
			o.controls.empty();
		}

		function close() {
			o.controls.find('.parameter-menu').hide();
		}
	}
});
