/*
 *  basic_chart/plugins/fail
 *
 *  This chart mixin adds a 'failed' icon if the plot request fails.
 *
 */
define(['jquery'], function($) {

	return function(chart, o){
		var self = this;
		self._el = $([]);
		self._product = chart.instance;

		(chart.bus || chart.options.messageBus).listen('product-swapped', function() {
			unsubscribe();
			remove();
			self._product = chart.instance;

			chart.instance.on.load_start.subscribe(self, remove);

			chart.instance.on.load_end.subscribe(self, function() {
				setTimeout(function() {
					if(chart.product._failed){
						self._el = chart.container.div('.fail ui-icon ui-icon-alert-fff');
						chart.grey();
					}
				}, 0);
			});
		});

		this.destroy = function() {
			unsubscribe();
		}

		function remove() {
			setTimeout(function() {
				self._el.remove();
				self._el = $([]);
			}, 0);
		}

		function unsubscribe() {
			self._product && $.each(['load_start', 'load_end'], function(i, name) {
				self._product.on[name].unsubscribe(self);
			});
		}
	}
});
