/*
 *  Mixin for the BasicChart widget to handle tropical cyclones.
 */
define(['jquery', 'unit'], function($, Unit) {

	function Tcyclone() {
	}

	Tcyclone.prototype = {
		tcyclone_init: function() {
			console.log('tcyclone_init');
			var self = this;    
			/* 
			self.instance.variables = [];
			self.instance.variables.push({'type' : 'dynamic', name: 'unique_id', title: 'Unique id'});
			self.instance.variables.push({'type' : 'dynamic', name: 'year', title: 'year'});
			*/

			/*
			if(self.instance.data.product.variables) // TODO should be handled by the validator
			self.instance.data.product.variables.push({'type': 'location', name: 'location', title: 'Location'});
			self.instance.data.modifiable.location = true;

			// ENS history
			self.instance.data.history = [];
			if ('ensgram-history' in localStorage) {
				if (localStorage['ensgram-history'] != 'undefined' && localStorage['ensgram-history'] != '') {
					self.instance.data.history = JSON.parse(localStorage['ensgram-history']);
				}
			} else {
				localStorage['ensgram-history'] = '[]';
			}
			*/

			//self.instance.data.product.variables.push(templates.forecast_base_time);
			/* 
			if (! self.instance.data.product.variables) {

				console.log("variables not defined");

				self.instance.data.product.variables = [];
				self.instance.data.product.variables.push({'type' : 'choice', name: 'unique_id', title: 'Unique id', values:['XYZ']});
				self.instance.data.modifiable.unique_id = true;
				self.instance.data.product.variables.push({'type' : 'choice', name: 'year', title: 'year', values:['2015']});
				self.instance.data.modifiable.year = true;
			};
			self.instance.data.values = {
				'unique_id': 'XYZ',
				'year': '2015'
			};
			values = {};
			self._set_parameters($.extend({},self.instance.data.values, values));
			*/

			self.instance.events
				.bind('image-changed', function() {
					$.fn.wwwChartParameterBar && // TODO
					self.parameter_bar.wwwChartParameterBar('setItems', $.extend(templates.forecast_base_time, {
						values: $.map(self.instance.data.availability.availability, function(a){ return a[0]; }),
						labels: $.map(self.instance.data.availability.availability, function(a){ return new Time(a).asText(); })
					}));

					self._history.update.call(self);
					self._metadata.update.call(self);
				})
				.bind('load-end', function(){
					self._stop_spinner();
					if(self.instance.error_msg){
						self.bus.send('log-error', {title: 'Plot failed', message: self.instance.error_msg});

					}else if(self.instance.data.is_fall_back) {
						self.bus.send('log-warning', {title: 'Fallback plot', message: 'The requested plot is not available. A fallback is displayed.'});

					}
				});
		},

		_history: {
			block: $('#block-ecmwf-chart-history'),
			content: $('#block-ecmwf-chart-history .history-content').empty().ul('.chart-history'),
			update: function () {
				var self = this, history = self._history;
				if(this.instance.has_widget('epsgram')){
					history.block.show();
					history.content.html($.map(self.instance.data.history, self._bind(history._render)));

					//TODO: Move to a proper place
					localStorage['ensgram-history'] = JSON.stringify(self.instance.data.history);
				}
			},
			_render: function(org, i) {
				var self = this;

				var location = org.axis.station_name || $.formatLatitude(org.axis.lat) + ' ' + $.formatLongitude(org.axis.lon);
				var time = new Time([org.axis.base_time, 0, org.axis.base_time]);
				var date = org.axis.base_time ? time.base_time.format('dd mmm HH:MM') : '';
				var type = org.axis.epsgram.replace('classical_', '');
				type     = type.charAt(0).toUpperCase() + type.slice(1);

				var out = $('<li>');
				out.div().div(location);
				out.div().div(date);
				out.div().addClass('epsgram-type').div(type);

				require(['tooltip'], function(){
					out.modeTooltip({
						maxWidth: 'auto',
						content: function() {
							return location + ' - ' + type + (date ? ' - ' + time.base_time.toString() : '');
						}
					});
				});

				return out.click(function() {
					$(this).modeTooltip('close');
					self._set_parameters(org.axis);
					self._update_page();
				});
			}
		},

		_metadata: {
			update: function () {
				var self = this, meta = self._metadata;

				require(['help-panel', 'markup'], function(){
					if(!meta.block){
						// increase width for bartik to allow for both wide content and 3rd column:
						meta.block = $('#block-ecmwf-chart-ecmwf-chart-metadata');

						self.element.helpProvider({getContent: function(){
							return {content: meta.get_epsgram_help.call(self)};
						}});
					}

					$.when(self.element.helpProvider('getContent')).then(function(out){
						out || (out = {});
						out.content || meta.block.hide();
						out.content &&
							meta.block.show().find('.metadata-content')
								.markup(out.content || 'no information available')
								.siblings('.title').find('> span').text(out.title || 'No Help')
								.trigger('loading', 'false');
					});
				});
			},

			get_epsgram_help: function () {
				var self = this;
				var list = [];
				console.log('metadata.get_epsgram_help: metadata=', self.instance.data.metadata);

				if (!self.instance.data.metadata) {
					return 'Cannot get help information.';
				}
				var metadata = self.instance.data.metadata;

				if (!metadata.distance) {
					return 'Cannot display help information. Missing Distance data.';
				}

				var m = Unit.get('m');
				var km = Unit.get(metadata.distance.distance_unit || 'km');

				var gridpoint_type = (metadata.land_sea_mask < 0.5) ? "sea" : "land";

				metadata.title && list.push("### " + metadata.title );
				list.push("Location requested: **" + $.formatGeoLocation(metadata.requested_location) + "**.  ");
				list.push("Nearest ENS grid point: **" + $.formatGeoLocation(metadata.location) + '**.');
				list.push('');

				if (metadata.height !== "" &&  metadata.height !== -9999 && metadata.db !== "10_days_wave") {
					console.log("metadata.height:<" , metadata.height, ">");
					list.push("Height of requested location (based on the GTOPO30 dataset): **" + m.asHTML(metadata.height) + "**, ");
					if (metadata.db != "plumes") {
						list.push("height of ENS orography at nearest grid point: **" + m.asHTML(metadata.eps_height) + "**, ");
						list.push("height of high resolution orography interpolated to ENS resolution at nearest grid point: **" + m.asHTML(metadata.deterministic_height) + '**.');
					}
					if (metadata.temperature_correction) {
						list.push('');
						if(metadata.temperature_adjustment) {
							list.push('Temperature parameter is adjusted to the requested location by **' + $.formatCelcius(metadata.temperature_adjustment.deterministic_adjustement, 1) + '**' + ' in high resolution forecast curve and ' + '**' + $.formatCelcius(metadata.temperature_adjustment.eps_adjustement, 1) + '** in ENS forecast curves.');
						}
						else
						{
							list.push('Temperature parameter is adjusted to the requested location');
						}
						list.push('');
					}
				}
				list.push('');
				list.push('');
				//TODO: Fix me later
				if (metadata.db === "10_days_wave") {
					list.push("The nearest ENS grid point is located at **" + km.asHTML(metadata.distance.distance) + " " + metadata.distance.direction + "** of the selected location.");
				}
				else {
					list.push("The nearest ENS grid point is a **" + gridpoint_type + " point**, ");
					list.push("located at **" + km.asHTML(metadata.distance.distance) + " " + metadata.distance.direction + "** of the selected location.");
				}

				/* $.each(metadata, function(k,v) { list.push("* " + k + " = " + v); }); */

				return list.join("\n");
			},
			block: null
		}
	}

	var templates = {
		forecast_base_time: {name: 'base_time', title: 'Forecast base time', type: 'retention', values: []}
	}

	return Tcyclone;

});
