
define(['jquery'], function ($) {
	/*
	 *   Now is a jquery plugin instead of jquery.ui widget due to known issues with leaks
	 *   when widgets are used by other widgets. 
	 */
	$.fn.latlong = function(args, event){

		var o = $.extend({
			chart: undefined
		}, args || {});

		return $(this).each(function() {
			var el = $(this);

			if(typeof args === 'string'){
				var self = el.data('latlong');
				switch(args){
					case 'destroy':
						self.chart = null;
						self.event = null;
						self.update = null;
						el.removeData('latlong');
						break;
					case 'update':
						self.event = event;
						self.update();
						break;
					default:
						break;
				}
			}else{
				el.data('latlong', {
					chart: o.chart,
					update: $.throttle(100, function () {
						var self = el.data('latlong');
						var os = self.chart.img.offset();
						var x = self.event.pageX - os.left;
						var y = self.event.pageY - os.top;
						var latlong = o.chart.product.position(x, y);
						if (latlong) {
							el.html($.formatGeoLocation(latlong.lat, latlong.lon));
						}
					})
				});

				el.addClass('latlong text-overlay');
			}
		});
	}

});
