define(['config', 'jquery', 'ajax_queue', 'unit'], function(ECMWF, $, Ajaxqueue, Unit) {

    function Layer(layer) {

        this.get_title = function() {
            var title = layer.title;
            if(layer.variable_title) {
                var re = /(\$\w+)/g;
                title = layer.variable_title.replace(re, function(txt) {
                    var name = txt.substr(1);
                    if(layer.values) {
                        txt = layer.values[name];
                        if(layer.variables) {
                            $.each(layer.variables, function(_,v) {
                                if(v.name === name) {
                                    if(v.unit) {
                                        var unit = Unit.get(v.unit);
                                        if(unit) {
                                            txt = unit.asHTML(txt);
                                            return;
                                        }
                                    }

                                    if(v.labels) {
                                        txt = Array.isArray(v.labels) ? v.labels[$.inArray(txt, v.values)] : v.labels[txt];
                                        return;
                                    }

                                    return;
                                }
                            });
                        }
                    }
                    return txt;
                });
            }
            return title;
        };

        this.hash = function() {
        }

        this.get_help_content = function(item, product, size){
            var self = this;
            size || (size = {width: 242, height: 50});

            return $.Deferred(function(dfd){

                item.title = self.get_title();

                var d1 = $.Deferred(function(dfd){
                    Ajaxqueue({
                        url          : '/backend/get-layer-help/',
                        cancelled_by : product.owner,
                        priority     : 'low',
                        cache        : 24 * 60 * 60,
                        json         : { name: layer.name },
                        success      : function(result) {
                            dfd.resolve(item.help = result ? result.help : 'Failed to get help');
                        },
                        error        : function(){
                            dfd.resolve(item.help = 'Failed to get help');
                        }
                    });
                });

                var d2 = $.Deferred(function(dfd){
                    if(layer.has_data) {

                        Ajaxqueue({
                            url          : '/backend/layer-legend/',
                            cancelled_by : product.owner,
                            priority     : 'low',
                            cache        : 24 * 60 * 60,
                            json         : { product: product.as_json(size, null), layer: layer.id },
                            success      : function(result) {
                                result && (item.legend = result.url);
                                dfd.resolve();
                            },
                            error        : function(){
                                dfd.resolve();
                            }
                        });
                    }
                    else {
                        dfd.resolve();
                    }
                });

                $.when(d1.promise(), d2.promise()).then(dfd.resolve);

            }).promise();
        }

        this.is_visible = function() {
            //note that unlike the methods above, this uses 'this', rather than the closure context.
            return this.visible;
        }

        return this;
    }

    return Layer;
});

