define(['jquery', 'bus'], function($, Bus) {

	$.chartAnimationRangeController = function() {
		var rc = this;

		this.range = [{}, {}];

		$.animationAddFilter(this.animation_client = $.extend(new $.AnimatorClient(), {
			getFrames: null,

			//return false if outside current range
			filter: function(time){
				/*
				console.log('  ', [time.valid_time.json], (rc.range[0].time ? [rc.range[0].time.valid_time.json] : null), (
					(!rc.range[0] || !rc.range[0].time || (time.valid_time.getTime() - rc.range[0].time.valid_time.getTime() >= 0)) &&
					(!rc.range[1] || !rc.range[1].time || (time.valid_time.getTime() - rc.range[1].time.valid_time.getTime() <= 0))
				));
				*/
				return(
					(!rc.range[0] || !rc.range[0].time || (time.valid_time.getTime() - rc.range[0].time.valid_time.getTime() >= 0)) &&
					(!rc.range[1] || !rc.range[1].time || (time.valid_time.getTime() - rc.range[1].time.valid_time.getTime() <= 0))
				);
			}
		}));

		Bus()
			.listen('chart-product-availability', function(event, msg){
				//rc.base_times = msg.valid_time;
				$.animationUpdateFilter(rc.animation_client);
			})
			.listen('animation-set', function (_, msg) {
				if(msg.range){
					rc.range[0].time = msg.range.start;
					rc.range[1].time = msg.range.end;
					//console.log('chartAnimationRangeController: start=', [rc.range[0].time.valid_time.json]);
					$.animationUpdateFilter(rc.animation_client);
					Bus().send('chart-animation-selection-change', msg.range);
				}
			});
	}

	$.chartRegisterPlugin('animationRangeController', $.chartAnimationRangeController);

});
