/*
 *  Add an icon indicating that the chart is clickable
 *
 */
define(['jquery', 'chart'], function($) {

	return function(chart, o) {

		var icon = $([]);
		chart.options.messageBus.listen('chart-content-update', function() {
			if(chart.product.has_widget('clickable')){
				icon = icon.length ? icon.show() : chart.element.div('.clickable')
					.css({position: 'absolute', top: 4, left: 4, zIndex: 10, height: 14, width: 14, padding: 0, border: 'solid 4px rgba(1,1,1,0.5)'})
					.attr({title: 'Click on the chart to get location information'})
			}else{
				icon.hide()
			}
		})

		this.destroy = function() {
			icon.remove()
		}
	};
});
