/*
 *  basic_chart/parameter_select
 *
 *  This chart mixin creates a menu bar for parameter selection.
 *
 *  ** This uses the Select widget and not the Menu widget as in the original version.
 *
 *  TODO is a duplicate of basic_chart/parameter_select - resolve differences and merge
 *     differences to resolve:
 *       - chart-content-update vs product-swapped-and-loaded
 *       - chart.product vs chart.instance
 */
define(['jquery', 'bus', 'basic_chart/parameter_controls/factory', 'basic_chart/parameter_select.css'], function($, Bus) {

	return function(chart, o) {

		o.controls.addClass('chart-parameter-bar');

		chart.bus.listen('chart-content-update', function(msg) {
			o.controls.show().find('.parameter-control').remove();

			if($.isEmptyObject(chart.product.variables)){
				o.controls.p().text('No modifiable parameters');
			}else{
				$.each(chart.product.variables, function(i, param) {
					o.controls.div('#' + param.name + '-navigator')
						.basicControlFactory({
							parameter: param,
							instance: chart.product,
							bus: chart.bus,
							on_select: function(val){
								console.log('catalogue2.basic.control.on_select: ', val);
								Bus().send('add-page-state');
							}
						});

					typeof param === 'choice' && console.warn('parameter_menu: parameter-type choice not handled');
				});
			}
			o.controls.show();
		});

		$('body').off('click', close).click(close);

		this.destroy = function() {
											chart.bus.forget(this); // not needed. chart is destroyed so should not emit messages.
			o.controls.empty();
		}

		function close() {
			o.controls.find('.parameter-menu').hide();
		}
	}
});
