
define(['config', 'jquery', 'chart'], function(ECMWF, $) {

	$.chartRegisterPlugin('Save', function(chart) {
		chart
			._listen('menu-save-product-select', function() {
				ECMWF.dialogue({
					title: 'Save Product as ...',
					items: [
						// Todo, find good defaults
						{
							type: 'string',
							name: 'title',
							value: 'My Product',
							title: 'Name'
						}, {
							type: 'text',
							name: 'description',
							value: '',
							title: 'Description'
						}, {
							type: 'text',
							name: 'keywords',
							value: '',
							title: 'Keywords'
						}
					],
					ok: function(choices) {
						chart.product.save_product(choices, function(result) {
							chart.options.messageBus.send('new-product-added-to-catalogue', result);
						});
					}
				});
			})
			._listen('menu-save-projection-select', function() {
				ECMWF.dialogue({
					title: 'Save Projection as ...',
					items: [
						// Todo, find good defaults
						{
							type: 'string',
							name: 'title',
							value: 'My Projection',
							title: 'Name'
						}, {
							type: 'text',
							name: 'description',
							value: '',
							title: 'Description'
						}, {
							type: 'text',
							name: 'keywords',
							value: '',
							title: 'Keywords'
						}
					],
					ok: function(choices) {
						chart.product.save_projection(choices, function(result) {
							chart.options.messageBus.send('new-projection-added-to-catalogue', result);
						});
					}
				});
			})
			._listen('menu-save-dashboard-select', function() {
				var items;

				if (ECMWF.request.widget) {
					items = [{
						type: 'string',
						name: 'title',
						value: ECMWF.request.widget.title || 'Chart',
						title: 'Name'
					}, {
						type: 'text',
						name: 'description',
						value: ECMWF.request.widget.description || '',
						title: 'Description'
					}, {
						type: 'text',
						name: 'keywords',
						value: ECMWF.request.widget.keywords || '',
						title: 'Keywords'
					}, {
						type: 'boolean',
						name: 'save_as_new',
						title: 'Save as new Widget',
						'default': false
					}];
				} else {
					items = [{
						type: 'string',
						name: 'title',
						value: chart.product.title(),
						title: 'Name'
					}, {
						type: 'text',
						name: 'description',
						value: '',
						title: 'Description'
					}, {
						type: 'text',
						name: 'keywords',
						value: '',
						title: 'Keywords'
					}];
				}

				ECMWF.dialogue({
					title: 'Save to Dashboard as ...',
					items: items,
					ok: function(choices) {
						if (ECMWF.request.widget) {
							choices.widget = ECMWF.request.widget.name;
						}
						chart.product.add_to_dashboard(choices, function(result) {
							window.location.href = ECMWF.options.site.dashboard;
						});
					}
				});
			});

		this.destroy = function() {
		}
	});
});
