/*
 *   Manage the contents of a page element outside the chart
 *   displaying detailed layer and time information.
 */
define(['jquery', '../layer', 'chart'], function($, Layer) {

	$.chartRegisterPlugin('wwwTitle', function(chart) {
		var self = chart, o = self.options;

		var el = $('<div>', {'class': 'layer-title'});
		var h3 = el.h3();
		var h4 = el.h4();

		chart.options.messageBus.listen('chart-content-update', function() {
			var product = chart.product;

			var title = [];
			$.each(product.layers_by_id, function(i, lyr) {
				var layer = new Layer(lyr);
				if (lyr.has_data)
					title.push(layer.get_title());
			});

			h3.html(title.join(' / '));
			if(product.variables.time){
				h4.html(product.variables.time.value.asText(true));

				//FIXME: Product attribute should not be set here
				product.www_title = title.join(' / ') + '\n' + product.variables.time.value.asText(true);
			}

			el.insertAfter('.chart-controls');
		});

		chart.options.messageBus.listen('chart-time-select', function(_, time) {
			h4.html(time.asText(true));
		});

		this.destroy = function() {
			el.remove();
		}
	});
});
