/*
 *  CSS-only spinner designed to work with Ajaxqueue.
 *  Changes to 'active' mode when request goes from 'queued' to 'active'
 */
module.exports = function status(el) {

	var data = el.data('status') || {}
	data.a || (
		(data.a = el.div('.spin')).div('.a'),
		data.b = data.a.div('.b'),
		el.data('status', data)
	)

	var hide = {opacity: 0, visibility: 'hidden'}

	return function(state) {
		switch(state){
			case 'queued':
				data.stopped = false;
				setTimeout(function(){
					data = el.data('status')
					data.stopped || data.a.css({visibility: 'visible', opacity: 1.0})
				}, 500)
				break;
			case 'active':
				setTimeout(function(){ // single spinner looks better so dont show double unless really needed
					el.data('status').stopped || data.b.css({visibility: 'visible', opacity: 0.5})
				}, 1500)
				break;
			case 'complete':
			case 'canceled':
			case 'aborted':
				data.stopped = true;
				data.a.css(hide)
				setTimeout(function(){
					data.b.css(hide)
				}, 400)
		}
		el.data('status', data)
	}
}

