define(['jquery'], function($) {

    var _oldShow = $.fn.show;
    var _oldHide = $.fn.hide;

    $.fn.show = function(speed, oldCallback) {
        return $(this).each(function() {
            var obj = $(this), newCallback = function() {
                if ($.isFunction(oldCallback)) {
                    oldCallback.apply(obj);
                }

                obj.trigger('afterShow');
            };

            // you can trigger a before show if you want
            obj.trigger('beforeShow');
            obj.trigger('visibilityChange', { visible: true });

            // now use the old function to show the element passing the new callback
            _oldShow.apply(obj, [speed, newCallback]);
        });
    };

    $.fn.hide = function(speed, oldCallback) {
        return $(this).each(function() {
            var obj = $(this), newCallback = function() {
                if ($.isFunction(oldCallback)) {
                    oldCallback.apply(obj);
                }

                obj.trigger('afterHide');
            };

            // you can trigger a before hide if you want
            obj.trigger('beforeHide');
            obj.trigger('visibilityChange', { visible: false });

            // now use the old function to hide the element passing the new callback
            _oldHide.apply(obj, [speed, newCallback]);
        });
    };


});
