var Schema = {
    "version": 1.0,

    "image_format": {
        "name"  : "image_format",
        "title" : "Image Format",
        "type"  : "choice",
        "value" : "png",
        "values": ["png", "svg"],
        "labels": {"png": "PNG", "svg": "SVG (experimental)" },
        "menu"  : true
    },

    "print_format": {
        "name"  : "print_format",
        "title" : "print format",
        "type"  : "choice",
        "value" : "png",
        "values": ["PNG", "PDF", "SVG"],
        "menu"  : true,
        "editable" : false
    },

    "show_latlong": {
        "type" : "boolean",
        "name" : "show_latlong",
        "title": "Show Coordinates",
        "value": true
    },

    "font_size" : {
        "name"  : "font_size",
        "title" : "Font Size",
        "type"  : "choice",
        "value" : "normal",
        "values": ["normal", "large"],
        "menu"  : true,
        "editable" : false
    },

    "pallettes" : {
        "name"  : "pallettes",
        "title" : "Preserve Floating Pallettes",
        "type"  : "boolean",
        "value" : false,
        "editable" : false
    },

    "default_location" : {
        "name"  : "default_location",
        "title" : "Default Location",
        "type"  : "point",
        "value" : {"lat": 0, "lon": 0, "title": ""}
    },

    "animation_speed" : {
        "name"  : "animation_speed",
        "title" : "Animation Speed",
        "type"  : "float",
        "range" : [-8, 11],
        "value" : 1.0,
        "editable" : false
    },

    "chart__enable_scrollwheel": {
        "name"  : "chart__enable_scrollwheel",
        "title" : "Enable Scrollwheel",
        "type"  : "boolean",
        "value" : true
    },

    "notification_autoclose": {
        "name"  : "notification_autoclose",
        "title" : "Close notifications automatically",
        "type"  : "choice",
        "value" : "0",
        "values": ["0", "1", "5", "30", "60"],
        "labels": {"0": "never", "1": "1 minute", "5": "5 minutes", "30": "30 minutes", "60": "1 hour"},
        "menu"  : true
    },

    "height_adjustment": {
        "name"  : "height_adjustment",
        "title" : "Enable Meteogram Height Adjustment",
        "type"  : "boolean",
        "value" : true
    },

    "dashboard_autoupdate": {
        "name"  : "dashboard_autoupdate",
        "title" : "Auto update Dashboard widgets",
        "type"  : "boolean",
        "value" : false
    },

    "notifications_disable": {
        "name"  : "notifications_disable",
        "title" : "Notifications Disable",
        "type"  : "boolean",
        "value" : false,
        "editable" : false
    },

    "tooltips_disable": {
        "name"  : "tooltips_disable",
        "title" : "Tooltips Disable",
        "type"  : "boolean",
        "value" : false,
        "editable" : false
    }
}
export default Schema;
