/*
 *  This widget displays a piece of server-side HTML.
 *  It is not user-editable.
 */
define(['config', 'jquery', 'bus', 'ajax_queue', './widget'], function(ECMWF, $, Bus, DashboardWidget, Ajaxqueue) {

$.widget('ui.htmlDashboardWidget', $.ui.dashboardWidget, DashboardWidget.register('htmlDashboardWidget', {

	factory : {
		kind  : 'html',
		title : 'New html widget',
		data  : { name : 'empty' },
		is_private : true //user cannot instantiate.
	},

	options: {
		messageBus: Bus()
	},

	_init: function() {
		var self = this, o = this.options;

		$.ui.dashboardWidget.prototype._init.call(this);
		self.element.addClass('html-dashboard-widget');

		Ajaxqueue({
			url       : ECMWF.options.ajax.backend.get_snippet,
			json      : {snippet_name: o.data.name},
			success   : function(result) {
				self.p = self.content.p(result);
			},
			logErrors : ECMWF.options.ajax.backend.get_snippet,
			error     : function(result){}
		});
	},

	destroy: function() {
		this.element.removeClass('html-dashboard-widget');
	}
}));

});
