import $ from 'jquery'
import Bus from 'bus'
import Time from 'time'
import './data_availability.css'

function availability(self, bus, parent, a1, all) {

    var bt = {};
    var vt = {};
    var vts = [];
    var bts = [];

    self.ready = false;

    $.each(a1, function(_, d){

        var b = d.base_time.json || (d.base_time.json = d.base_time.toJSON());
        var v = d.valid_time.json || (d.valid_time.json = d.valid_time.toJSON());

        if (!bt[b]) {
            bt[b] = true;
            bts.push(d.base_time);
        }

        if (!vt[v]) {
            vt[v] = true;
            vts.push(d.valid_time);
        }

    });

    var b_idx = {};
    bts = bts.sort(function(a, b){
        return a - b;
    });
    $.each(bts, function(i, d){
        b_idx[d.toJSON()] = i;
    });

    var latest = bts[bts.length - 1];

    var v_idx = {};
    vts = vts.sort(function(a, b){
        return a - b;
    });
    $.each(vts, function(i, d){
        v_idx[d.toJSON()] = i;
    });

    var len = vts.length;
    function index(i, j){
        return i * len + j;
    }

    var avail = [];
    //var selected;
    //var cells = {};

    $.each(a1, function(_, d){
        var b = d.base_time.json;
        var v = d.valid_time.json;
        avail[index(b_idx[b], v_idx[v])] = d;
    });

    var table = self.table = $("<table>");
    var undefined;

    var tr = $("<tr>", {"class": "header"})
        .appendTo(table)
        .append("<td>")
        .click(function(){
            parent.empty();
            availability(self, bus, parent, a1, !all);
        });


    var first = all ? 0 : v_idx[latest.json];
    // first = 0;
    if(first === undefined) {
        first = 0;
    }
    var cnt = 0, last, day = vts[first].format("ddd dd mmm"), date = vts[first];


    function add() {

        function title() {
            var t = date.format("ddd").substr(0, 1);
            if (cnt > 2) { t = date.format("ddd"); }
            if (cnt > 5) { t = date.format("ddd dd"); }
            if (cnt > 7) { t = date.format("ddd dd mmm"); }
            return t;
        }

        $("<td>", {
            text: title(),
            "class": date.format("ddd"),
            colspan: cnt,
            data: { date: date }
        }).appendTo(tr);
    }

    //console.info("DATE ", date.format("ddd dd mmm"));

    for (j = first; j < vts.length; j++) {
        day = vts[j].format("ddd dd mmm");
        if (day !== last) {
            if (cnt) {
                add();
                cnt = 0;
            }
            date = vts[j];
        }
        last = day;
        cnt++;
    }

    if (cnt) {
        add();
    }

    tr = $('<tr>').appendTo(table).addClass('time').append('<td>');
    for (j = first; j < vts.length; j++) {
        var x = vts[j].format('HH');
        $('<td>').html(x).appendTo(tr).data({ date: vts[j] });

        //if(j < first) td.hide();
    }

    var i, j;
    table.delay(0); // make sure the queue is not run immediatly
    self.element.resize();
    for (i = bts.length - 1; i >= 0; i--) {

        (function(i){
            table.delay(0).queue(function(next){
                var tr = $("<tr>"), n = 0;
                $("<td>").addClass("base").text(bts[i].format("dd mmm HH") + "Z").appendTo(tr).data({
                    date: bts[i]
                });
                for (j = first; j < vts.length; j++) {
                    var id = index(i, j);
                    var a = avail[id];
                    var t = new Time(bts[i], undefined, vts[j]);
                    var td = $("<td>").attr("id", t.key).attr('tabindex', -1).addClass(a === undefined ? "no" : "yes").html("&nbsp;").appendTo(tr);

                    if (a) {
                        a.id = t.key;
                        td.data(a);
                        n++;
                    }
                }
                if (n) {
                    tr.appendTo(table);
                    self.element.resize();
                }

                next();
                self.ready = true;

                if(i === 0) {
                    self._select_time();
                }
            });
        }(i));
    }

    parent.parents('.menu-pane').css({width: ''}); // remove any now incorrect width settings
    table.appendTo(parent);

    /*var tbody = */table.find('tbody');

    var tip = $('body > .tip').orelse(function(){ return $("<div>").addClass("tip").css("position", "absolute").hide().appendTo("body"); });

    $(table).on('click', '.yes', function(e){
        var d = $(this).data();
        if (d) {
            bus.send("slider-time-change", d);
        }
    });
    /*
            .live('keydown', function(event) {
                var el = $(this);
                var col = el.index();
                var row = el.parent().index();
                if(!el.hasClass('yes')) return;
        });
    */

    function hover(selector, title){
        $(document).on('mouseenter mouseleave', selector, function(e){
            var d = $(this).data();
            if (d && (e.type === "mouseover" || e.type === "mouseenter")) {
                var o = $(this).offset();
                tip.html(title(d)).css({
                    top: o.top - tip.outerHeight(true) - 3,
                    left: o.left - 10
                }).show();
                $(this).addClass("hover");
            }
            else {
                tip.hide();
                $(this).removeClass("hover");
            }
        });
    }

    hover(".yes", function(d){
        return d.base_time.format("dd mmm HH") +
            "Z T+" +
            d.step +
            ", " +
            d.valid_time.format("dd mmm HH") +
            "Z";
    });

    hover("tr.header > td", function(d){
        return (d && d.date) ? d.date.format("ddd dd mmm yyyy") : null;
    });

    hover("tr.time td", function(d){
        return (d && d.date) ? d.date.format("ddd dd mmm yyyy HH") + "Z" : null;
    });

    hover(".base", function(d){
        return d.date.format("ddd dd mmm yyyy HH") + "Z";
    });
}


    var count = 0;
    //var max = 200;

    $.widget("ui.dataAvailability", $.extend({}, {

        // Widget created with
        // $("#foo").dataAvailability({ foo: 23, "bar": "eee" })

        options: {
            messageBus: Bus(),
            counter: $('<span>')
        },

        _init: function(){
            var self = this, o = this.options;

            count++;

            self.name = "data_availability_" + count;
            self.count = 0;

            self.element.addClass("data-availability");

            o.counter.hide().addClass("data-availability-counter").html(self.count);

            o.messageBus
                .listen("chart-product-availability", function(event, msg){

                    setTimeout(function(){
                        self._update(msg.availability, msg.current, msg.update_number, msg.updated);
                    }, 0);
                })
                .listen("chart-content-update", function(_, d) {
                    console.log('availability.on_chart_content_update', self._show_date(d.time));
                    if(d && d.changed.get('time') && d.time){
                        self.current = d.time;
                        self._select_time();
                    }
                })
                .listen("chart-time-select", function(_, d) {
                    //console.log('availability: on_chart_time_select:', self._show_date(d));
                    self.current = d;
                    self._select_time();
                });

            self._reset();
        },

        _reset: function(txt){
            var self = this;
            self.element.empty().html("Waiting...").resize();
        },

        _update: function(avail, current, update_number, updated){
            var self = this, o = this.options;

            if(self.update_number != update_number) {
                self.element.empty();
                self.current = current
                availability(self, o.messageBus, self.element, avail, 0);
                self.update_number = update_number;
                self.updated       = updated;

                $("<div>").addClass("updated").text("Last update: " + new Date(updated*1000)).appendTo(self.element);
            }
        },

        destroy: function(){
            var self = this;

            self.element.removeClass("ui-widget ui-widget-content ui-corner-all data-availability");

            // Cleanup CSS and event handling
            // self.element.removeClass("....").unbind("....")
            // Destroy created DOM elements
            self.element.empty();

            return this;
        },

        _show_date: function(d){
            if(d) return 'BT' + d.base_time.format('mmdd/HH:MM') + ' VT' + d.valid_time.format('mmdd/HH:MM');
        },

        _select_time: function(){
            var self = this;

            if(self.current && self.ready){
                self.table.find("td.selected").removeClass("selected");
                self.table.find("#" + self.current.key).addClass("selected")
                    .orelse(function(){ console.log('availability: selection not found:', self._show_date(self.current)); })
                    .each(function(){
                        if(!$(this).hasClass('yes')) console.warn('availability: selecting a date not in the availability!', self._show_date(self.current));
                    });
            }
        },

        _verify_current: function(avail){
            var self = this;

            var found_ = false;
            $.each(avail, function(i, e){
                if(e && (self.current.key === e.key)){
                    found_ = true;
                    console.log('availability: found: basetime=' + self.current.base_time.format('mmdd/HH:MM') + ' validtime=' + self.current.valid_time.format('mmdd/HH:MM'));
                }
            });
            if(!found_){
                console.warn('availabilility: invalid current time: ' + self.current.key, self.current);
                self.element.div('current date is not within displayed range').addClass('warning');
            }
            return found_;
        }
    }));


    $.ui.dataAvailability.eventPrefix = 'dataAvailability';

    $.ui.dataAvailability.defaults = $.extend({}, {
        messageBus: Bus(),
        counter: $('<span>')
    });

