;(function($){ 

var registry = {};

$.fn.decorator = function(options) {
    if(!options) return this;

    if(typeof options == 'string'){
        var decorator_type = options;
    } else {
        var decorator_type = options.decorator;
    }
    //console.log('decorator: type=' + decorator_type);

    if(!registry[decorator_type]){ console.warn('decorator: no such decorator type: ' + decorator_type); return this; }

    return this.each(function() {
        registry[decorator_type].apply($(this));
    });
};

function Decorator(name, fn){
    registry[name] = fn;
}

new Decorator('ecmwf', function(options) {
    //this will implement the reference design, following further discussions with the design company.
});

new Decorator('shadow', function(options) {
    this.addClass('decorator-shadow');
});

new Decorator('glow-shadow', function(options) {
    this.shadow_box();
});

})(jQuery);
