define(['jquery', 'bus'], function($, Bus){
	$(document).ready(function(){

		var options = [
			{select: on_select, title:'Valid Time', decorator: 'glow-shadow'},
			{select: on_select, mode: 'ui-dialogue', title:'Valid Time'},
			//{mode: 'normal', select: on_select}, //FIXME this now gives an error!
			//{decorator: 'shadow', select: on_select}
			{decorator: 'glow-shadow', select: on_select}
		];

		$('<div/>', {id: 'chart-container'})
			.appendTo('#main-column')
			.append($('<div/>', {'class': 'content', id: 'chart'}))
			.decorator('glow-shadow')
			.find('.content')
			.chart()

		var selectors = $('<div/>')
			.add('<div/>')
			.add('<div/>', {id: 'date-select2'})
			.add('<div/>', {id: 'date-select-bottom'})
			.each(function(i, t){
				$(this)
					.appendTo('#main-column')
					.dateSelect(options[i]);
			});

		$('<div style="position:relative; left: 190px; top:-16px;">&lt;-- Using ui-dialog (broken since 1.8 upgrade)</div>')
			.insertAfter(selectors[1]);

		var output = $('<div><div class="content">No date selected</div></div>')
			.appendTo('#main-column')
			.decorator('glow-shadow')
			.find('.content');

		Bus().listen('chart-product-availability', function(event, msg){
			var max_items = 2000;
			var i = 0;
			var dates = $.map(msg.valid_time.values, function(a) { if(i++ < max_items) return a['valid_time'] });
			selectors.dateSelect('setDates', dates, msg.current.valid_time);
		});

		function on_select(date){
			output.html('<b>Selected date</b>: ' + date);
			selectors.dateSelect('setDate', date);
		}
	});
})
