/*
 *  A popup dialogue designed to be used with the ECMWF form widget.
 */
define(['jquery', 'browser', 'bootstrap_modal', 'bootstrap_modal/bootstrap_modal.css'], function($, Browser) {

var options = {
		id          : '',
		title       : '',
		header_text : undefined,
		html        : '',
		resizable   : false
		//buttons: undefined // eg: '<input type="button" value="Cancel" class="btn"/><input type="submit" value="Ok" class="btn primary"/>'
}

function Dialogue2013(args) {

		var self = this, o = self.options = $.extend({}, options, args)
		this.element = $('body');

		var form_exists = o.id && !!$('#' + o.id).length;
		form_exists || $('<div id="' + o.id + '" class="modal hide' + ((Browser.msie && Browser.version) > 9 ? '' : ' fade') + '">' +
			'<div class="modal-header"><a href="#" class="close bootstrap-close" data-dismiss="modal">&times;</a>' +
			'  <h2>' + o.title + '</h2>' +
			(o.header_text ? ('<p class="header-text">' + o.header_text + '</p>') : '') +
			'</div>' +
			'<form method="post" action="' + o.action + '" class="modal-form">' +
			'<div class="modal-body">' +
			o.html +
			'</div>' +
			'<div class="modal-footer">' +
			(o.buttons || '') +
			'</div>' +
			'</form>' +
			'</div>').appendTo('body');

		var modal = $('.modal');

		o.resizable && modal.resizable().bind('resize', function(event, ui) {
			ui.element.css({
				marginLeft: -ui.size.width/2,
				marginTop: -ui.size.height/2,
				top: '50%',
				left: '50%'
			});
			ui.element.css('height', ui.size.height + $('.modal-footer').outerHeight());
			$(ui.element).find('.modal-body').each(function() {
				$(self).css('max-height', ui.size.height - $('.modal-header').outerHeight() - $('.modal-footer').outerHeight());
			});
		});

		Browser.msie && (Browser.version > 10) && modal.bind('shown', function() {
			console.log('dialogue2013.shown: display=', modal.css('display'));
			setTimeout(function(){
				__DEV__ && console.log('dialogue2013.shown.timeout: display=', modal.css('display'));
				(modal.css('display') === 'none') && (
					__DEV__ && console.warn('dialogue2013: showing dialogue that should already be shown'),
					modal.show()
				);
			}, 1000);
		});
}

Dialogue2013.prototype = {
	getElements: function(){
		var el = $('#' + this.options.id)
		return {
			modal: el,
			h: el.find('h2'),
			body: el.find('.modal-body'),
			form: el.find('form'),
			footer: el.find('.modal-footer')
		};
	}
}

return Dialogue2013;

});
