define(['jquery'], function($) {

function Emitter() {
	this._listeners = {},

	this.bind = function(name, fn) {
		this._listeners[name] || (this._listeners[name] = []);
		this._listeners[name].push(fn);
		return this;
	}

	this.unbind = function(name, fn) {
		var e = this;
		if(e._listeners[name]){
			if(fn){
				$.each(e._listeners[name], function(i, v){ if(v === fn) delete e._listeners[name][i]; });
			}else{
				delete e._listeners[name];
			}
		}
		return e;
	}

	this.send = function(name, value) {
		var e = this;
		if(e._listeners[name]){
			e._listeners[name].length && console.info('SEND ', name, value);
			for(var f in e._listeners[name]){
				e._listeners[name][f](value);
			}
		}
	}
}

return Emitter;

});
