/**
 *  Plugin to assign consecutive tab indexes.
 *
 *  An app can be initialised using $.fn.focusable(). This will make all focusable elements focusable.
 *  Individual elements can be made focusable by calling element.focusable();
 */
define(['jquery'], function($) {

var tab_index = 1;

$.fn.focusable = function(args) {
    var options = $.extend(args, {});

    if(!this.length){
        var elem = $('body');
        elem.find('input').addClass('focusable');
        elem.find('textarea').addClass('focusable');
        elem.find('select').addClass('focusable');

        elem.find('.focusable').each(function() {
            add($(this));
        });

        return this;
    }

    return this.each(function() {
        add($(this));
    }); 

    function add(el){
        return el
            .attr('tabindex', tab_index++)
            .click(function() { $(this).focus(); });
    }
};

});
