/*
 * ECMWF Browser check
 */
define(['config', 'jquery', 'core/browser'], function(ECMWF, $){

$.fn.browserCheck = function(){

    if(ECMWF.browser.msie) {
        try {
            document.createStyleSheet();
        } catch(e){
            $('body').append('<h1>Browser Error: Exceeded max includes.</h1>');
            $('.menu-item').hide();
            $('#status-bar').hide();
            return;
        }
    }

    var referral1 = '<p>Your browser is reporting itself as <i>NAME ' + ECMWF.browser.version + '</i></p>';
    var referral2  = "";
    // FIXME
    try {
        referral2 = '<p>Please refer to the <a href="' + ECMWF.options.settings.eccharts_help + '">ECMWF WREP browser compatibility page</a> for more information.</p>';
    }
    catch(e)
    {
    }
    var referral = referral1 + referral2;
    var msg;

    $.each(ECMWF.browser, function(i, val) {
        if(typeof val === 'function' || val === 'version' || i === 'msie8' || i === 'msie7') return;
        switch(i){
            case 'mozilla':
                var v = ECMWF.browser.version.split(/\./);
                if(v.length >= 3 && (v[0] < 2)){
                    if((v[1] < 9) || (v[1] < 10 && v[2] < 1)){
                        msg = '<h3>The ECMWF Forecaster application currently does not fully support your browser</h3>' +
                              '<p>If possible, please upgrade to a minimum of <i>Firefox 3.5</i> or equivalent.</p>' +
                              referral2.replace('NAME', i);
                    }
                }
                break;
            case 'chrome':
                break;
            case 'webkit':
                var e = ECMWF.browser.engine();
                if(e.version < 500){
                    msg = '<h4>The ECMWF Forecaster application currently does not fully support your browser</h4>' + referral.replace('NAME', i) + ', engine version ' + e.version;
                }
                break;
            case 'msie':
            case 'msie9':
                v = ECMWF.browser.version.split(/\./);
                if(v.length >= 2 && (v[0] < 7)){
                    msg = '<h4>The ECMWF Forecaster application currently does not fully support your browser</h4>' + referral.replace('NAME', i);
                }

                //compensate for MSIE8 compatibility mode reporting
                if(document.documentMode){
                    if(ECMWF.browser.version === '7.0'){
                        ECMWF.browser.version = '8.0';
                    }
                }
                if(ECMWF.browser.version === '7.0'){
                    $('body').addClass('msie7');
                }

                break;
            case 'safari':
            case 'version':
                break;
            default:
                (typeof val !== 'function') && (msg = '<h4>Unrecognised user-agent</h4>' + referral.replace('NAME', i));
                break;
        }
	});
	msg && require(['inline-message'], function() {
		$('#inline-messages').inlineMessage({message: msg, mode:'warning'});
	})

	delete $.fn.browserCheck;

	return this;
};

});
