define(['config', 'jquery', 'ajax_queue', 'bus', 'core/clone'], function(ECMWF, $, Ajaxqueue, Bus, clone) {

return function(args) {

	var o = $.extend({
		bus: Bus()
	}, args || {});

	o.bus
		.listen('menu-help-report-select-alt', function (_, msg) {
			// If the menu is selected with shift or add
			Bus().send('send-magics-stuff');
		})
		.listen('menu-help-report-select', function (_, msg) {
			var report = {
				window: {
					width: $(window).width(),
					height: $(window).height()
				},
				now: new Date(),
				loaded_at: ECMWF.timestamp.format('yyyymmddhhMMss'),
				ajax: Ajaxqueue.info(),
				errors: $.lastErrors(),
				ecmwf : ECMWF
			};

			// Collect info
			Bus().send('collect-report-info', report);
			report.description = 'email follows';

			function submit_report_via_mailto() {
				$.logMessage('Submitting report ...', null, {timeout: 1000});
				//console.log('report:', clone.serialise(report));
				// PLEASE NOTE THAT THIS INTERUPTS ALL OUTSTANDING AJAX REQUESTS
				// We need something like:
				// javascript:window.open('mailto:me@somewhere.com'; return false;)
				location.href = 'mailto:eccharts-support@lists.ecmwf.int?subject=ecCharts issue&body=Please describe your problem here';

				//window.open('mailto:eccharts-support@lists.ecmwf.int?subject=ecCharts issue&body=Please describe your problem here');
			}

			function submit_report_via_ajax() {
				//var retry_min_later = 0.0;

				Ajaxqueue({
					url: '/backend/report/',
					priority: 'very-high',
					statistics: false,
					log_error: 'Sending report',
					json: $.cleanupObject(report),
					success: function () {
						$.logMessage('Report submitted');
					},
					error: function (e) {
						/*
						$.logWarning('Report submit failed - will retry in ' + Math.floor(retry_min_later * 60) + ' seconds ...');

						if (retry_min_later < 0.6) {
							setTimeout(function () {
								$.logMessage("Retrying report submit...");
								//submit_report_via_ajax();
							},
							1000 * 60 * retry_min_later);

							retry_min_later = Math.min(retry_min_later + 0.135, 1.0);
						} else {
							var msg = 'Failed to submit report';
							$.logError(msg);
							alert(msg);
						}
						*/
					}
				});
			}

			function open_dialogue() {
				var text =
					'<p>For urgent issues and to report ecCharts service problems, please send email to the 24/7 ECMWF <a href="mailto:calldesk@ecmwf.int?Subject=ecCharts%20Report%20Issue:%20">calldesk@ecmwf.int</a>.</p>' +
					'<p>For general requests, please refer to the instructions in the <a href="https://software.ecmwf.int/wiki/display/ECCHARTS/">documentation</a> or send email to <a href="mailto:eccharts-support@lists.ecmwf.int?Subject=ecCharts%20Report%20Issue:%20"> eccharts-support@lists.ecmwf.int</a>.</p>'

				$('<div>' + text + '</div>')
					.dialog({
						title : 'Report issue',
						autoOpen: false,
						modal : true,
						dialogClass: 'report-issue',
						resizable: false,
						width: 350,
						buttons: {
							'Ok': function() { $(this).dialog('close').remove(); }
						}
					})
					.dialog('open')
					.shadowFix()
					.find('p').addClass('font-size-medium');
			}

			setTimeout(submit_report_via_ajax, 10);
			//setTimeout(submit_report_via_mailto, 10);
			setTimeout(open_dialogue, 10);
		});
};

});
