//TODO add test for printing. check for error returned from plot?
define(['jquery', 'bus', 'test-lib', 'chart/testable'], function($, Bus, Tests, ChartTestable) {
ChartTestable = ChartTestable || window.ChartTestable;

console.log('running tests...');

$.when(
		$.Deferred(function(df){
			$(function(){
				df.resolve()
			})
		})
	).then(function(){

	var dont_run = [
		/*
		'Check Product Catalogue',
		'Check Projection Catalogue',
		'Add Remove Product',
		'Layers Dialogue',
		'Add Remove Layer',
		'Load Product',
		'Time Series',
		'Cities',
		'Meteograms',
		'Probe',
		'Legends',
		'Info',
		'Change Valid Time',
		'Change Base Time',
		*/
		'Set Animation Range', // flakey
		'Set Animation Step size',
		'Restore Basetime'
	]

	var bus = Bus();
	var anim;
	setTimeout(function(){
			log({message: 'Running...'});

			var tests = new Tests([
			{
				name: 'Check Product Catalogue',
				start: function(){
					var test = ct.test = this;
					new Series([
						ct.open_product_catalogue,
						ct.close_product_catalogue,
						test.finished
					], this).run();
				}
			},

			{
				name: 'Check Projection Catalogue',
				start: function(){
					var test = this;
					new Series([
						function(){ $('#projections-menu').click(); return wait_for('#projections:visible'); },
						this.bind(this.wait_for, ['#projections .items > .thumbnail:visible', 'waiting for thumbnails']),
						function(){ $('#projections > .more > a').click(); return this.wait_for('#projection-select:visible'); },
						this.bind(this.wait_for, ['#projection-select .catalogue-grid:visible', 'grid visible']),
						this.bind(this.wait_for, [function() { return $('#projection-select .catalogue-grid:visible').length > 20 }, 'grid items']),
						function(){ $('#projection-select .ui-icon-close').click(); return test.wait_for_remove('#projection-select', 'selector remove'); },
						function(){ $('#projections-menu').click(); return test.wait_for_remove('#projection-select', 'remove'); },
						test.finished
					], this).run();
				}
			},

			{
				name: 'Add Remove Product',
				start: function(){
					var test = ct.test = this;
					new Series([
						ct.add_product,
						ct.remove_product,
						test.finished
					], this).run();
				}
			},

			{
				name: 'Layers Dialogue',
				start: function(){
					var test = this;
					test.set_timeout(10000);
					var button = '#gadget .button.layers';
					new Series([
						_wait_for(button, 'layers'),
						function(){ $(button).click(); return this.wait_for('#layer-list-pane:visible', 'layer-list'); },
						function(){ test.set_timeout(20000); },
// TODO this never fails
						this.bind(this.wait_for, [function(){ return $('#layer-list-pane #layer-list tbody > tr:visible').length > 1; }, 'layer-list rows']),
						function(){ $('#layer-list .add-layer').click(); },
						_wait_for('#layer-select', 'layer-select'),
						function(){
							return test.wait_for(function(){ return $('#layer-select .grid-items .item').length > 1 }, 'layer thumbnails');
						},
						function(){ $('#layer-select .close').click(); },
						function(){ $(button).click(); },
						test.finished
					], this).run();
				}
			},

			{
				name: 'Add Remove Layer',
				start: function(){
					var test = ct.test = this;
					new Series([
						ct.add_remove_layer,
						ct.add_remove_layer,
						ct.add_remove_layer,
						ct.add_remove_layer,
						ct.add_remove_layers,
						ct.close_layer_list,
						test.finished
					], this).run();
				}
			},

			{
				name: 'Load Product',
				start: function(){
					var test = ct.test = this;
					ct.change_product('efi_tp', function(){
						ct.change_product('rh_850uv', function(){
							ct.change_product('efi_tp', test.bind(test.finished));
						});
					});
				}
			},

			{
				name: 'Time Series',
				start: function(){
					enable_view('time-series', this.bind(this.finished));
				}
			},

			{
				name: 'Cities',
				start: function(){
					enable_view('cities', this.bind(this.finished));
				}
			},

			{
				name: 'Meteograms',
				start: function(){
					var test = this;
					enable_view('meteograms', test.bind(test.finished), function(){
						return $.Deferred(function(df){
							function remove_meteogram(done){
								test.set_timeout(15000);
								test.assert(($('#meteograms .content li').length > 0), 'cannot remove meteogram. none to remove');
								var item = $('#meteograms .content li:first');
								test.assert((item.length === 1), 'cannot find item');
								// because the tools use hoverIntent, we cannot use a simple event to open them
								item.find('.meteogram').thumbnailTools('show', true);
								var button = item.find('.tools .ui-icon-trash')
								test.assert((button.length > 0), 'cannot find button');
								var title = item.find('.meteogram-title span').text();
								console.log('title=', title);
								test.assert((title.length > 0), "meteogram has no title");
								if(!title.length) return;
								button.click();
								test.wait_for(function(){
									return ($('#meteograms span:contains(' + title + ')').length === 0);
								}, 'title').then(done);
							}

							remove_meteogram(function(){
								$('#meteograms .more a:last').click();
								test.wait_for('#meteogram-select:visible').then(function(){
									test.wait_for('#meteogram-select .catalogue-grid .item').then(function(){
										var n_meteograms = $('#meteograms .content > ul > li').length;
										console.log('>>> clicking...');
										click($('#meteogram-select .catalogue-grid .item img:first'));
										//we could also check for this message: 'multigrams-list-changed'
										test.wait_for(function(){
												return $('#meteograms .content > ul > li').length == (n_meteograms + 1);
											}, 'n_items + 1')
											.then(function(){
												$('#meteogram-select .close').click();
												setTimeout(function(){
													df.resolve();
												}, 1000);
											});
									}, 'selector items');
								}, 'selector open');
							});
						});
					});
				}
			},

			{
				name: 'Probe',
				start: function(done){
					var test = ct.test = this;

					enable_view('probe', this.bind(this.finished), function(){
						return $.Deferred(function(df){
							ct.change_product('efi_tp', function(){
								bus.clear('latlon-location-select').listen('latlon-location-select', function(_, marker) {

									$('#probe .content tbody tr').each(function() {
										test.assert($(this).find('td:first').text().trim() === 'Total precipitation extreme forecast index', 'layer name');
									});

									var loc;
									test.wait_for(function(){
											loc = {
												lat: +$('#probe .location .latlon:eq(0)').text(),
												lon: +$('#probe .location .latlon:eq(1)').text()
											};
											return loc.lat === marker.lat && loc.lon === marker.lon;
										}, 'probe latlon update')
										.then(df.resolve);
								});
								bus.send('latlon-location-select', {lat: 53, lon: 0});
							});
						}).promise();
					});
				}
			},

			{
				name: 'Legends',
				start: function(done){
					enable_view('legends', this.bind(this.finished));
				}
			},

			{
				name: 'Info',
				start: function(done){
					enable_view('info', this.bind(this.finished));
				}
			},

			{
				name: 'Change Valid Time',
				start: function(){
					var test = this;

					$('#availability-menu').click(); //show availability so we can monitor BT/VT changes.

					test._listen_once('chart-time-select', this.bind(test.finished));

					var button = $('.ec-toolbar .next-step');
					test.assert(button.length === 1, 'next step button');
					button.click();
				}
			},

			{
				name: 'Change Base Time',
				start: function(){
					var test = ct.test = this;
					var max_iter = Math.min(4, $('#time-navigator .date-select select option').length);
					var i = 0;
					function next(){
						ct.set_base_time(i, ++i < max_iter ? test.bind(next) : test.bind(test.finished));
					}
					next();
				}
			},

			{
				name: 'Set Animation Range',
				start: function(){
					var test = this;
					//bus.send('animationcontrols-animation-selection-change', {name: 'efi_tp', use_product_projection: true});
					enable_view('controls', test.bind(this.finished), function(){
						return $.Deferred(function(df){
							test.set_timeout(30000);
							var start_frame = 2;
							var animation_length = 3;
							var act = new AnimationControlsTestable();
							$.when(act.range.set(start_frame, start_frame + animation_length - 1)).then(function(){
								anim || (anim = new TestAnimator());
								anim.test = test;
								anim.start(function(frame_list){
									test.assert(frame_list.length === animation_length, 'incorrect frame count');
									console.log('load complete. n_frames=', frame_list.length);

									new Series([
											// cannot add starting the animation to the task list, as the frame list is needed in advance.
											//function(){
											//	return anim.start(function(_frame_list){
											//		frame_list = _frame_list;
											//		test.assert(frame_list.length === animation_length, 'incorrect frame count');
											//		console.log('load complete. n_frames=', frame_list.length);
											//	});
											//}

											//now that we have the framelist, restart the animation to make sure we dont miss the first frame
											function(){ return anim.stop(); },
											function(){ return anim.go_to(frame_list[0]); },
											function(){ return anim.start(); }
										], test)
										.each(frame_list, function(i){
											console.log('adding... ', ' len=', this.tasks.length);
											this.push(function(){ return anim.expect_frame(frame_list[i]); });
										})
										.merge([
											function(){ return anim.expect_frame(frame_list[0]); },
											function(){ console.log('---------------------------------------------------------------'); },
											function(){ return anim.stop(); },
											function(){ return anim.go_to(frame_list[0]); },
											function(){ return anim.start(); }
										])
										.each(frame_list, function(i){
											this.push(function(){ return anim.expect_frame(frame_list[i]); });
										})
										.push(function(){
											return act.range.selector2.select(start_frame + 3);
										})
										.push(function(){
											anim.stop();
											df.resolve();
										})
										.run();
								});
							});
						});
					});
				},
				finished: function(msg){
					anim.stop();
					this.prototype.finished(msg);
				}
			},

			{
				name: 'Set Animation Step size',
				start: function(){
					var test = this;

					// check the product is suitable - will fail if not enough steps ?
					// TODO check the availability
					/*
					var c = $('#chart').data('uiChart');
					c.product.availability(c.time, function(){
						console.log('   avail:', arguments);
					});
					*/

					enable_view('controls', this.finished, function(){
						return $.Deferred(function(df){
							test.set_timeout(40000);
							var start_frame = 2;
							var animation_length = 12;
							var act = new AnimationControlsTestable();
							act.test = test;
							$.when(act.range.set(start_frame, start_frame + animation_length - 1)).then(function(){
								anim || (anim = new TestAnimator());
								anim.test = test;

								$.when(act.set_step_size(24)).then(function(){
									anim.start(function(frame_list){
										test.assert(anim.running === true, 'bad animator client state (running not set)')
										test.assert(frame_list.length <= animation_length, 'frame count too high: ' + animation_length + ' > ' + frame_list.length);
										test.assert(frame_list.length === anim.current_framelist.frames.length, 'incorrect frame count');
										console.log('load complete. n_frames=', frame_list.length);

										var previous_n_frames = frame_list.length;
										$.when(act.set_step_size(12)).then(function(){
											test.assert(anim.current_framelist.frames.length > previous_n_frames, 'frame count not increased following step-size reduction: ' + previous_n_frames + ' --> '  + anim.current_framelist.frames.length);
											$.when(anim.stop()).then(function(){
												test.assert(anim.running === false, 'bad animator client state (running)')
												test.finished();
											});
										});
									});
								});
							});
						});
					});
				}
			},

			/*
			{
				name: 'Test workspaces',
				start: function(){
					var test = this;

					Workspaces.list(function(workspaces){
						var n_workspaces = ECMWF.n_properties(workspaces);
						var products = Workspaces.map(function(w){ return w.settings && w.settings['last-product'].name; });
						Workspaces.add('Test 1', function(workspace){
							test.assert(ECMWF.n_properties(workspaces) === n_workspaces + 1, 'wrong number of workspaces');
							test.assert(Workspaces.current !== workspace.name);
							test.assert(workspace.title === 'Test 1', 'New workspace name incorrect');
							console.log('', n_workspaces, '-->', ECMWF.n_properties(workspaces));
							console.log('products=', products);
							Workspaces.select(workspace, function(workspace){
								test.assert(compare_products(products).length !== 1, 'product check failed');
								products = Workspaces.map(function(w){ return w.settings && w.settings['last-product'] && w.settings['last-product'].name; });
								select_each_workspace(function(){
									test.finished();
								});
							});
						});
					});

					function select_each_workspace(done){
						var products = Workspaces.map(function(w){ return w.settings && w.settings['last-product'] && w.settings['last-product'].name; });
						return $.Deferred(function(df){
							var queue = $({});
							Workspaces.each(function(workspace){
								//console.log('item:  w=', w.name);
								queue.queue(function(next){
									test.set_timeout(10000);
									Workspaces.select(workspace, function(w){
										console.log('dequeue:    w=', workspace.name);
										test.assert(!compare_products(products).length, 'product check failed');
										setTimeout(function(){
											next();
										}, 3000);
									});
								});
							});
							queue.queue(function(next){
								console.log('queue finished');
								done && done();
								df.resolve();
								next();
							});
						}).promise();
					}

					function compare_products(products){
						//compare the given product list with the current one. return an array of products that dont match.
						var current = Workspaces.map(function(w){ return w.settings && w.settings['last-product'] && w.settings['last-product'].name; });
						//console.log('compare: products=', current);
						var diff = [];
						$.each(products, function(i, p){
							//console.log('compare_products: ', products[i], current[i]);
							if(products[i] !== current[i]) diff.push(products[i]);
						});
						$.each(current, function(i, p){
							//console.log('compare_products: ', products[i], current[i]);
							if(products[i] !== current[i]) diff.push(products[i]);
						});
						return diff;
					}
				}
			}*/
			{
				name: 'Restore Basetime',
				start: function(){
					var test = ct.test = this;
					ct.set_base_time(0, test.bind(test.finished));
				}
			}]);

			var ct = new ChartTestable(this);
			ct.bus = bus;

			$('#chart').chart('option', 'availability', null); // TODO - this has no effect?

			tests.dont_run(dont_run).run();

	}, 2000);

	function enable_view(view_type, done, test){
		//test: if a function is passed as this parameter, it will be run after showing the view. It must return a $.Deferred.
		test || (test = function(){ return $.Deferred().resolve(); });

		bus.send('menu-views-' + view_type + '-change', {value: true});
		wait_for('#' + view_type + ':visible')
			.pipe(sleep)
			.pipe(test)
			.pipe(function(value){
				return disable_view(view_type);
			})
			.then(done);
	}

	function disable_view(view_type){
		return $.Deferred(function(df){
			console.log('disable_view: ', view_type);
			bus.send('do-menu-views-' + view_type + '-change', {value: false});
			setTimeout(function(){
				df.resolve();
			}, 2000);
		});
	}

	var wait_for = Test.wait_for;
	var _wait_for = function(fn){
			return function(){ return wait_for(fn); }
	}
	var sleep = Test.sleep;

	function AnimationControlsTestable(css){
		var ct = new ChartTestable;
		this.test = null;
		this.range = {
			selector1: new ct.DateSelector('#controls .date-select:first'),
			selector2: new ct.DateSelector('#controls .date-select:eq(1)'),
			set: function(start_frame, end_frame){
				var self = this;
				return $.Deferred(function(df){
					self.selector1.select(start_frame, function(){
						self.selector2.select(end_frame, function(){
							df.resolve();
						});
					});
				}).promise();
			}
		}
		this.set_step_size = function(step_size){
			var sizes = {all: 0, 24: 1, 12: 2, 6: 3, 3: 4};
			return $.Deferred(function(df){
				bus.clear('animation-set').listen_once('animation-set', function(_, msg){
					//anim.running && console.log('set_step_size: is running');
					msg.filter && df.resolve();
				});
				var s = sizes[step_size];
				console.log('set_step_size: s=', s);
				$('#controls .increment input:eq(' + s + ')').click();
			}).promise();
		}
	}

	function TestAnimator(){
		var self = this;
		bus.listen('animation-start', function(){ self.running = true;  });
		bus.listen('animation-stop',  function(){ self.running = false; });
		$.animationAddFilter(this);
	}
	TestAnimator.prototype = $.extend(new $.AnimatorClient(), {
		start: function(done){
			return $.Deferred(function(df){
				bus.clear('chart-animation-load-complete').listen_once('chart-animation-load-complete', function(event, frame_list){
					done && done(frame_list);
					df.resolve();
				});
				if(true === false)
					$('#chart').chart('animator').start(); // currently the animator is lazily instantiated so is not available until an animation been started.
				else
					bus.send('tool-animation-start');
			}).promise();
		},
		stop: function(){
			// this is stop, not pause.
			var self = this;
			return $.Deferred(function(df){
				if(!self.running) return df.resolve();
				bus.clear('animation-stop').listen_once('animation-stop', function(e, frame){
					self.test.assert((($('.chart-image').length === 1) && ($('.chart-image:visible').length === 1)), 'n visible charts ' + $('.chart-image:visible').length + ' (expected 1)');
					//TODO can we check the displayed frame is the correct one?
					df.resolve();
				});
				$('#chart').chart('animator').stop();
			}).promise();
		},
		go_to: function(time){
			var self = this;
			return $.Deferred(function(df){
				console.log('goto:       ...listening...');
				bus.clear('chart-time-select').listen_once('chart-time-select', function(e, frame){
					console.log('goto: ok');
					// time-select should have destroyed the animation frames.
					self.test.wait_for_remove('.chart .frame').done(function(){
						df.resolve();
					});
				});
				bus.send('slider-time-change', time);
			}).promise();
		},
		expect_frame: function(time){
			var self = this;
			this.test.set_timeout(10000);
			return $.Deferred(function(df){
				console.log('* listening...');
				bus.clear('chart-time-select').listen_once('chart-time-select', function(e, frame){
					console.log('frame! msg=', frame.valid_time);
					self.test.assert((frame.valid_time.getTime() === time.valid_time.getTime()), 'wrong frame: ' + frame.valid_time.json + ' expected: ' + time.valid_time.json)
						&& df.resolve();
				});
			}).promise();
		},
		getFrames: null,
		frameList: function(list, first){
			//console.log('TestAnimator.frameList: ', list, first);
			this.current_framelist = {frames: list, first: first}
		}
	})

	function Series(tasks, context){
		this.tasks = tasks;
		this.run = function(){
			$({}).queue($.map(this.tasks, function(task){ return function(next){ /*console.log('Series: task=', task);*/ $.when(task.apply(context)).then(next); }}));
		}
		this.push = function(task){
			this.tasks.push(task);
			return this;
		}
		this.each = function(list, fn){
			var self = this;
			$.each(list, function(i, item){
				fn.apply(self, arguments);
			});
			return this;
		}
		this.merge = function(array){
			this.tasks = $.merge(this.tasks, array);
			return this;
		}
	}

	function log(o){
		console.log(o.message);
		$.notify({
			id: 1,
			story: 'test',
			title: 'Test',
			message: o.message,
			kind: (o.kind || 'service-news')
		});
	}

	// provide a click with coordinates for cases where coords are needed by the event handler
	// TODO have many copies of this - move to test-lib
	function click(el) {
		var position = el.offset()
		console.log('click: position=', position)
		var x = position.left + el.width() / 2;
		var y = position.top + el.height() / 2;

		var ev = new MouseEvent('click', {
			'view': window,
			'bubbles': true,
			'cancelable': true,
			'screenX': x,
			'screenY': y
		})

		el[0].dispatchEvent(ev);
	}

});

});

