define(['config', 'jquery', 'focusable', 'thumbnail-dialogue'], function(ECMWF, $) {

return function ObjectListHandler() {

	this.options = {
		merge_user_catalogue: true
	}

	this.render = function (item) {
		var self = this;
		var div = $('<div>').a('Select ' + item._item.subtype + ' ...')
			.addClass('select-link')
			.prop('href', '#select')
			.attr('name', item.value)
			.focusable() //TODO tabindex not consecutive with other form elements.
			.click(function(){
				var el = $(this);
				$('body > .' + item._item.subtype + '-dialogue').each(function(){
					$(this).find('.filterable-thumbnail-list').dialog('open');
				}).orelse(function(){
					el.thumbnailDialogue({
						text: 'Please select one of these ' + item._item.title + 's',
						kind: item._item.subtype,
						merge_user_catalogue: self.options.merge_user_catalogue,
						actions: [{
							name: 'Select',
							on_click: function(selection){
								$('.filterable-thumbnail-list').dialog('close');
								div.attr({name: selection});
								if(self.on_update) self.on_update(item, selection);
							}}
						],
						hide_user_items: false,
						modal: true
					});
				});
				return false;
			});
		return div;
	};

	this.collect = function (item, widget) {
		return widget.attr('name');
	};
}

});
