/*
 *  Newer selector dialogue currently only supporting catalogue products
 *
 *  TODO dont open megathumbs after item is selected or dialogue is closed
 */
define(['config', 'jquery', 'focusable'], function(ECMWF, $) {

var dialogue;

return function ObjectListHandler() {

	__DEV__ && require( // preload
		['vgrid', 'vgrid/products', 'vgrid/filters/text', 'dialogue2013', 'virtual-dom/h', 'render-tree'],
		function(VGrid, products, text_filter, Dialogue){
			// find-product is very slow - call it preemptively
			products.set_package('catalogue');
			products.set_list();
		}
	)

	this.options = {
		merge_user_catalogue: true
	}

	this.render = function (item) {
		var self = this;
		var div = $('<div>').a('Select ' + item._item.subtype + ' ...')
			.addClass('select-link')
			.prop('href', '#select')
			.attr('name', item.value)
			.focusable() // TODO tabindex not consecutive with other form elements.
			.click(function(){
				if(dialogue) return dialogue.getElements().modal.modal('show')

				require(['vgrid', 'vgrid/products', 'vgrid/filters/text', 'dialogue2013', 'virtual-dom/h', 'render-tree'], function(VGrid, products, text_filter, Dialogue, h, RenderTree) {
					dialogue = new Dialogue({
						id: 'product-select',
						title: '<h2>Product select</h2>',
						html: '<div></div>'
					});
					var height = $(window).height() - 80;
					var width = Math.min(800, $(window).width() - 80)
					var el = $('#product-select')
						.css({width: width, height: height, marginTop: -height/2, marginLeft: -width/2})
						.modal('show')

					var modal_body = $('.modal-body')

					// TODO catalogue-grid is not created yet - why trying to measure it?
					var v_space = height - $('.modal-header').outerHeight() - $('.modal-footer').outerHeight() - modal_body.outerHeight() + (el.find('.catalogue-grid').outerHeight() || 0);

					el.find('.catalogue-grid').empty();

					var grid;
					var vdom = new RenderTree({
						root: modal_body.find('div')[0],
						tree: h('div'),
						main: {
							render: function() {
								// TODO ensure RenderTree waits for the next tick before first render
								return grid ? grid.render() : h('div')
							}
						}
					})

					grid = new VGrid({
						renderer: vdom,
						products: products,
						width: modal_body.width(),
						height: v_space,
						on_click: function(selection){
							console.log('ObjectListHandler: closing... selection=', selection);
							$('body > .tipsy').remove(); // TODO do this more systematically
							el.modal('hide');
							self.on_update && self.on_update(item, selection);
						}
					})

					products.add_filters([text_filter/*, facet_filter*/])

					// TODO this duplicates fn in grid.js - should be done in the list, not in the grid
					$.map(products.filters, function(f){
						$.isFunction(f.fn) && f.events && f.events.bind('changed', function() {
							products.filter();
							vdom.render();
						});
					});

					__DEV__ || products.set_package('catalogue'); // done in preload
					__DEV__ || products.set_list();               // done in preload
					__DEV__ && (products.on.items.value = 1, products.on.items.options.state = true); // TODO observable does not have a value?
					products.on.items.subscribe(self, function() {
						products.filter(); // TODO should be done inside the list
					});

					el.on('render', function() {
						vdom.render();
					});
				});
				return false;
			});
		return div;
	};

	this.collect = function (item, widget) {
		return widget.attr('name');
	};
}

});
