(function($){

var colours = [];
var loading_colours = [];
var colour_picker;

function ColourHandler() {

	// TODO: make it ajax ...
	var name2rgb = function(name) {

		try {
			return $.Color(name).fix().toHEX();
		}
		catch(e) {
			return name;
		}
	};

	this.parse = name2rgb;

	this.help  = function (id, item) {
		var list = [];
		list.push("<div style='display:none;position:absolute' id='" + id + "_colorpicker'><div></div></div>");
		return list.join("");
	};

	this.render = function (item) {

		if(colours.length === 0) {
			for(var c in $.color.palette.css3) { colours.push(c); }
		}

		var value  = item.get_defaults();
		var col    = name2rgb(value[0]);

		var input = $("<input/>")
			.attr({type: 'text', value: value[0]});

		if($.fn.onScreenKeyboard) {
			setTimeout(function() {
			input.onScreenKeyboard({});
		},10);
	}

		setTimeout(function() { input.parent().css({background: col}); });

		if(!colour_picker) {
			colour_picker = $("<div/>").css("position", "absolute").hide().appendTo("body");
			colour_picker.farbtastic();
		}

		input
			.focus(function() { 
				var col = name2rgb(input.val());
				$.farbtastic(colour_picker).setColor(col).linkTo(function(col) {
					var old = name2rgb(input.val());
					if(old !== col) {
						input.val(col);
					}
					input.parent().css({background: col});
				});

				var pos   = input.offset();
				var width = input.width();
				var height = input.height();

				var farb_width = 200;
				var left = (pos.left + width + 20);
				var form = item.widget.parents('.form:first');
				var css = {
					top  : pos.top + height + 5,
					left :
					(left < $(window).width() - farb_width)
						? left
						: form.position().left + form.offset().left - farb_width - 20
				}

				colour_picker.css(css).show();
			})
			.blur(function()  { 
				$.farbtastic(colour_picker).linkTo(function(){});
				colour_picker.hide(); 
			})
			.keyup(function() { 
				try {
					var col = name2rgb(text.val()); 
					$.farbtastic(picker).setColor(col);
					text.parent().css({background: col});
				} catch(e) {
					//console.log(e);
				}})
			.autocomplete({source: colours});

		return input;
	};
}
$.addFormHandler('colour', ColourHandler, 'String');

}(jQuery));
