define(['jquery', 'form', 'city-autocomplete'], function($) {

function CountryLocationHandler() {

	//TODO
	this.help  = function (id, item) {
		var list = [];
		list.push("<div style='display:none;position:absolute' id='" + id + "_location'><div></div></div>");
		return list.join('');
	};

	this.render = function (item) {
		var self = this;
		var value = item.get_defaults();

		function notify() {
			if(typeof item._item.city === 'function')
				item._item.city({ /*title : title.val(), */lat: parse_ll(self._lat.val()), lon: parse_ll(self._lon.val()) });
		}

		var ll = $('<div class="form-location"/>');
		this.finder = $('<input class="form-text">');
		var finder_wrapper = $('<div>').append(this.finder);

		ll.p('.country-location-help').html('<b>Please enter a country name</b><br/>You will then be able to select a location in the left column.');

		var html = $('<div>');
		html.prepend(ll);
		html.append(finder_wrapper);

		require(['city-autocomplete'], function() {
			self.finder.cityAutocomplete({
				name: 'Unnamed',
				is_country : true,
				select: function(event, ui){
					var pt = ui.item;
					delete self.save;
					item._item.country = pt;
					console.log('item item: ', item._item, pt);
					if(typeof item._item.city === 'function') item._item.city(pt);
				},
				close: function(event, ui) {
					if(self.save) {
						notify();
						delete self.save;
					}
				},
				focus: function(event, ui) {
					var pt = ui.item;
					if(typeof item._item.city === 'function') item._item.city(pt);
				}
			});
		});

		return html;
	};

	function parse_ll(text) {
		text = text.replace(",", ".");
		var val = parseFloat(text);
		if (text.indexOf("S") !== -1 || text.indexOf("s") !== -1 || text.indexOf("W") !== -1 || text.indexOf("w") !== -1) { val = -val; }
		return val;
	}

	this.collect = function (item, widget) {
		console.log('collect.item:', item);
		return {
			country : item._item.country
		}
	};
}

$.addFormHandler('country_location', CountryLocationHandler, 'String');

});
