define(['jquery', 'form'], function($){

function LocationHandler() {

	//TODO
	this.help  = function (id, item) {
		var list = [];
		list.push("<div style='display:none;position:absolute' id='" + id + "_location'><div></div></div>");
		return list.join('');
	};

	this.render = function (item) {
		var self = this;
		var value = item.get_defaults();

		function notify() {
			if(typeof item._item.city === 'function')
				item._item.city({ /*title : title.val(), */lat: parse_ll(self._lat.val()), lon: parse_ll(self._lon.val()) });
		}

		var ll = $('<div class="form-location"/>');

		ll.label('Latitude:');
		this._lat = ll.input({value: $.formatLatitude(value.lat, true), 'class': 'lat form-text'})
			.css({textAlign: "right"})
			.change(notify);

		ll.label('Longitude:');
		this._lon = ll.input({className: 'lon form-text', value: $.formatLongitude(value.lon, true)})
			.css({textAlign: "right"})
			.change(notify);

		ll.label('Altitude:');
		this._alt = ll.input({className: 'altitude form-text', value: value.altitude, disabled: true})
			.css({textAlign: "right"})

		this.finder = $('<input class="form-text">');
		var finder_wrapper = $('<div>').append(this.finder);

		var html = $('<div>');
		html.prepend(ll);
		html.append(finder_wrapper);

		html.p('.location-help').text('Please note that the lat/lon will not be updated unless an item is selected from the drop-down list, otherwise the text will be treated purely as a label');

		require(['city-autocomplete'], function() {
			self.finder.cityAutocomplete({
				name: 'Unnamed',
				select: function(event, ui){
					var pt = ui.item;
					self._lat.val($.formatLatitude(pt.lat, true));
					self._lon.val($.formatLongitude(pt.lon, true));
					self._alt.val(pt.altitude);
					delete self.save;
					if(typeof item._item.city === 'function') item._item.city(pt);
				},
				open: function(event, ui) {
					self.save = { lat: self._lat.val(), lon: self._lon.val() };
				},
				close: function(event, ui) {
					if(self.save) {
						self._lat.val(self.save.lat);
						self._lon.val(self.save.lon);
						notify();
						delete self.save;
					}
				},
				focus: function(event, ui) {
					var pt = ui.item;
					self._lat.val($.formatLatitude(pt.lat, true));
					self._lon.val($.formatLongitude(pt.lon, true));
					if(typeof item._item.city === 'function') item._item.city(pt);
				}
			});
		});

		return html;
	};

	function parse_ll(text) {
		text = text.replace(',', '.');
		var val = parseFloat(text);
		if (text.indexOf("S") !== -1 || text.indexOf("s") !== -1 || text.indexOf("W") !== -1 || text.indexOf("w") !== -1) { val = -val; }
		return val;
	}

	this.collect = function (item, widget) {
		return {
			lat: parse_ll(this._lat.val()),
			lon: parse_ll(this._lon.val()),
			city: this.finder.val(),
			altitude: this._alt.val()
		}
	};
}

$.addFormHandler('location', LocationHandler, 'String');

});
