define(['jquery', './products', './filter', './filters/facet', 'filterable-list', 'product_manager', 'facets', './filter_status', 'grid', './test.css'], function($, products, Filter, facet_filter, list){

$(function(){
	var page = $('.column.column-2').orelse(function(){ return $('#content'); });
	var wrapper = $('#centred');

	var selected_tags = [];

	//this filter will return false if one or more tags is selected, and the given item does not have any of these tags.
	var tag_filter = new Filter({
		name: 'tags',
		fn: function(item){
			if(!selected_tags.length) return true;

			var item_keywords = item.keywords.split(', ');
			console.log('tag_filter: keywords=', item.keywords, item_keywords);

			for(var i in item_keywords){
				for(var j in selected_tags){
					if(item_keywords[i] === selected_tags[j]){
						return true;
					}
				}
			}
			return false;
		},
		status: function(){
			return selected_tags.join(' ');
		}
	});

	requirejs.config({
		urlArgs: "bust=" + (new Date()).getTime()
	});

	var grid;
	function create_grid(products){
		list.set_collection(products);

		grid = page.div({id: 'list-1', css: {width: '85%'}})
			.grid({
				on_click        : function(name){ on_item_click(name); },
				filters         : [tag_filter, facet_filter],
				on_model_change : function(items){

					page.facets({
						products: products,
						on_change: function(a, b, val) {
							facet_filter.set(a, b, val);
						}
					});

					/*
					var tags = products.keywords('by_popularity');
					var k = page.find('.keyword-list ul').empty().orelse(function(){
						return page
							.div({'class': 'keyword-list'})
								.ul()
								.selectable({filter: 'li', stop: function(e, ui){

									selected_tags = [];
									//console.log('n_selected=' + $(this).find('li.ui-selected').length);
									$(this).find('li.ui-selected').each(function(){
										selected_tags.push($(this).find(':first').text());
									});

									//grid._lookup_filter_by_name('text').enable();
									tag_filter.enable();
									grid.grid('filter');
								}});
					});

					$('#content .keyword-list')[0].container_exclude = true;

					//TODO remove? is also in tinymce plugin
					var item = $.extend({}, items[0]);
					function fix(item){
						item.variables && $.each(item.variables, function(i, val){
							if(val.type === 'retention'){
								val.type = 'choice';
							}
						});
						return item;
					}
					// FIXME the backend changed so that it no longer contains the 'variables'
					item.variables && $('.form-items').empty().form({items: fix(item).variables, show_cancel: false});

					$.each(tags, function(i){
						k.li().div(this.name + '').addClass('column-1').parent().div(this.n + '');

						side.sideBlock('addLink', this.name, 'filter', function(text){
							console.log('click: name=', text);
							selected_tags = [text];
							tag_filter.enable();
							grid.grid('filter');
							return false;
						});
					});
					*/

					wrapper.triggerHandler('layout', {width: 400, height: $('body').height()});
				}
			});

			page.container({
				layout: 'vertical',
				expandable: grid
			});
	}

	if(true !== false){
		create_grid(products);
	}else{
		$('#content').div({id: 'list-1', css: {width: '80%', height: '80%', overflow: 'auto'}})
			.imageList({})
	}

	/*
	var side = $('#left-column').div().sideBlock({title: 'Keywords'})
		.addClass('keywords');
	*/

	/*
	page.div()
		.thumbnailList({
			kind: 'projection',
			visible_items: 2
		})
		.css({backgroundColor: '#f5f5f5', padding: 5, width: 422, position: 'relative', top: -30})
		.find('.thumbnail-list-filter').hide();
	*/
	page.div({'class': 'form-items'});

	//listen for changes
	$(document)
		.productManager();

	false && page.div().text('Hide Product Types').button().click(function(){
		var is_visible = grid.find('.product-types').is(':visible');
		grid.grid('show_product_types', !is_visible);
		$(this).find('span').text((is_visible ? 'Show' : 'Hide') + ' Product Types');
	});

	/*
	page
		.formElement()
		.change(function(a){
			var val = $(this).find('input:radio:checked').val();
			console.log('form.change val=', $(this).find('input:radio:checked').val());
			grid.remove();
			if(val === 'non_legacy'){
				console.log('  non legacy');
				create_grid(products);
			}
			if(val === 'legacy'){
				console.log('  legacy');
				//require(['/static/frontend/widgets/grid/legacy_products.js'], function(legacy_products){
					create_grid(products);
				//});
			}
		})
		.radio({
			buttons: ['legacy', 'non_legacy'],
			labels: ['Legacy Products', 'Non Legacy Products']
		});
	*/

	var north = $('#header')
	north.autoHeight = true;
	var south = $('#footer')
	south.autoHeight = true;
	wrapper.container({
		layout : 'border',
		north  : north,
		center : $('#main'),
		south  : south
	});

	$('#main').container({
		layout: 'vertical',
		expandable: page
	});

	var height;
	$(window).resize($.throttle(1000, function(){
		var new_height = $('body').height();
		if(new_height !== height){
			console.log('grid resize:', new_height);
			wrapper.triggerHandler('layout', {width: 400, height: $('body').height()});
			height = new_height;
		}
		return false;
	}));

	function on_item_click(product){
		console.log('click: ' + product.name());
		require(['preview'], function() {
			$(document).preview({model: product});
		});
	}
});

});
