define(['jquery', 'ajax_queue', './item_base'], function($, Ajaxqueue){

$.widget('ui.detailItem', $.ui.viewItemBase, {

	options: {
		item: null,
		kind: 'product',
		size: {x: 64, y: 24},
		grid: null
	},

	_create: function() {
		this.request_counter = 0;
	},

	_init: function() {
		var self = this, o = this.options;

		if(!o.item){
			self.existing = null;
			return self.element.addClass('empty').empty();
		}

		this._super();

		this.element.removeClass('empty').addClass('item detailItem')

		// using the normal thumbnail size and scaling it down
		self.img = self.element
			.find('img')
			.orelse(function(){
				return self.element.div('.img-wrapper')
					.img({className: 'thumbnail-img'})
			})
			.attr({
				src  : Ajaxqueue.options.host + '/backend/get-thumbnail/product/' + o.item.name() + '/',
				alt  : o.item.title_(),
				title: o.item.data.description,
				width: o.size.x,
				height: o.size.y
			});

		self.element
			.find('.col-title')
			.orelse(function(){
				return self.element.div('.col-title');
			})
			.text(o.item.title_());

		self.element
			.find('.col-description')
			.orelse(function(){
				return self.element.div('.col-description');
			})
			.each(function(){
				$(this)
					.text($('<div>').html((o.item.data.description != o.item.title_()) && o.item.data.description).text() || '')
					[o.item.description ? 'removeClass' : 'addClass']('not-available');
			});

		if(self.existing !== o.item.name()){
			var request = ++self.request_counter;

			/*
			o.item.thumbnail && o.item.thumbnail({size: o.size}, function(url, image, error){
				if((!error) && (request === self.request_counter)){
					self.img.css({height: 'auto', width: 'auto'}).attr('src', image || url);
				}
			});
			*/

			self.existing = o.item.name();
		}
	}
});

return {
	widgetName: 'detailItem',
	className: 'detailItem'
}

});
