define(['jquery', 'jquery-ui/widget'], function($){

$.widget('ui.viewItemBase', {
	options: {
		item: null,      // a copy - modifications will not be seen by caller. Is allowed to be null
		kind: 'product',
		grid: null,
		view: null,      // used to get read/write access the model.
		on_click: $.noop,
		on_dblclick: $.noop
	},

	_init: function() {
		var self = this, o = self.options;

		if(!o.item) return self.element.empty();
		if(!o.grid) return console.warn('viewItem.init: grid not set');

		self.bus = o.grid.options.bus;

		this.element
			.removeClass('selected')
			.off('click')
			.click(function(){
				o.on_click(o.item);
			})
			.dblclick(function(){
				o.on_dblclick(o.item);
			});
	},

	select: function() {
		this.element.addClass('selected');
	}
});

});
