/*
 *  The List view manages a list of dom elements displaying only the Title of the item.
 */
define(['jquery', '../assigned_item', './list_item', './view_base'], function($, AssignedItem, ItemView){

$.widget('ui.list', $.ui.viewBase, {

	_create: function() {
		var obj = $.ui.viewBase.prototype._create.apply(this, arguments);

		this.ItemView = ItemView;

		this.css_class = 'list-view';
		this.item_height = 15;
		this.item_width = 132;
		this.n_columns = 1;
		this.padding = {x: 0, y: 0};

		this.element.addClass(this.css_class);

		return obj;
	},

	_destroy: function() {
		console.log('listview.destroy');
		this.element.empty().removeClass(this.css_class);
		this._super();
	},

	_on_select: function(a, el) {
		//var o = this.options;
		console.log('listivew._on_select', a);
		this.options.click(a);
		//o.grid.container.find('.selected').removeClass('selected');
		//el.addClass('selected');
	},

	scroll: function(top) {
		var self = this, o = this.options, list = o.products;

		//var container_bottom = -top + self.element.parent().height();

		this.have.assignment.done(function() {
			var first_visible_result = Math.floor((-top) / self._height()) * self.n_columns;
			var last_visible_result = first_visible_result + self.cache.n_cells - 1;
			var to_reassign = [];
			for(var f=first_visible_result;f<first_visible_result+self.cache.n_cells;f++){
				if(!(f < list.filtered.length)) break;

				var m = list.filtered[f];
				if(!self._m_is_assigned(m)){
					to_reassign.push(m);
				}
			}
			var available = [];
			self._each_allocated(function(item, m, d){
				var ai = self.assigned[d];
				if((typeof ai.model_idx === 'undefined') || (ai.model_idx === null)){ console.warn('scroll: TODO error iterating over self.assigned. d=', d, ' ai=', ai, ' n_assigned=', self.assigned.length); return; }

				if(ai.filtered_idx < first_visible_result || ai.filtered_idx > last_visible_result || item.filter_pass !== true){
					//var item = self.items[ai.model_idx];
					//console.log('  available: ' + d + ': ' + item.name + ' row=' + (parseInt(ai.dom.css('top')) / self._height()) + ' filtered_idx=' + ai.filtered_idx + ' before=' + (ai.filtered_idx < first_visible_result) + ' after=' + (ai.model_idx > last_visible_result));
					available.push(d);
				}
			});
			if(to_reassign.length > available.length) console.warn('not enough available elements');
			for(var i in to_reassign){
				if(i < available.length){
					self._assign(available[i], to_reassign[i]);
				}
			}

			if(false && to_reassign.length){
				setTimeout(function(){
					for(var d in self.assigned){
						var ai = self.assigned[d];
						console.log('  ' + d + ': ' + ai.model_idx + ': x=' + ai.position.left + ' y=' + ai.position.top + ' ' + ai.dom.find('img').length);
					}
				}, 1000);
			}

			$.ui.viewBase.prototype.scroll.apply(self, arguments);
		});
	},

	resize: function() {
		var self = this, o = self.options;

		var old__n_visible_items = self.cache.n_cells;

		//how many items can we fit?
		var container_height = self.element.parent().height();
		self.cache.n_cells = self.n_columns * (Math.floor(container_height / self.item_height) + 1);
		//console.log('listview._resize: height=' + container_height + ' n_visible=' + self.cache.n_cells);

		for(var d=0;d<self.cache.n_cells;d++){
			self.assigned[d] = self.assigned[d] || new AssignedItem(self.widgetName, self.item_options);
			self.assigned[d].dom = self.assigned[d].dom || self.element.div();
		}

		if(self.cache.n_cells < old__n_visible_items){
			for(;d<old__n_visible_items;d++){
				self._unassign(d);
			}
		}

		o.products.have.filtering.done(function(){ self._assign_fresh(); });
		self._set_scrollbar_size();
	},

	_assign: function(dom_idx, model_idx) {
		var self = this, o = this.options;

		if(model_idx >= list.items.length) return;

		if(!self.assigned[dom_idx]){ console.warn('_assign'); self.assigned[dom_idx] = new AssignedItem('listItem', self.item_options); }

		$.ui.viewBase.prototype._assign.apply(this, arguments);

		var ai = self.assigned[dom_idx];

		var filter_idx = self._get_filter_idx(model_idx);
		var row = Math.floor(filter_idx / self.n_columns);
		var column = filter_idx % self.n_columns;
		//console.log('assign: m=' + model_idx + ' row=' + row + ' column=' + column + ' y=' + (row * self._height()));
		self.assigned[dom_idx].dom.css(ai.position = {
			top:  row * self._height(),
			left: self.item_width * column
		});
	},

	_height: function() {
		return this.item_height + 2 * padding.y;
	}
});

var padding = {x: 0, y: 5};

});
