/**
 *  Thumbnail view.
 */

define(['jquery', '../assigned_item', './thumb_item', './view_base'], function($, AssignedItem, ItemView){
var show_title = true;

$.widget('ui.thumbs', $.ui.viewBase, {

	_create: function() {
		var self = this, o = self.options;
		var obj = $.ui.viewBase.prototype._create.apply(this, arguments);

		this.ItemView = ItemView;

		this.item_height = 64 + (show_title ? 38 : 0);
		this.item_width = 127;
		this.padding = {x: 8, y: 16};
		this.n_columns = 0;

		show_title && (this.item_options.show_title = true);

		this.element.addClass('thumbs');

		return obj;
	},

	_destroy: function() {
		console.log('thumbs.destroy');
		this.element.empty().removeClass('thumbs');
		this._super();
	},

	scroll: function(top) {
		var self = this, o = this.options, list = o.products;

		this.have.assignment.done(function() {
			//var container_bottom = -top + self.element.parent().height();

			var visible_results = {
				first: Math.floor((-top) / (self.item_height + self.padding.y)) * self.n_columns
			}
			visible_results.last = visible_results.first + self.cache.n_cells - 1
			var to_reassign = [];
			for(var f=visible_results.first;f<visible_results.first+self.cache.n_cells;f++){
				if(!(f < list.filtered.length)) break;

				var m = list.filtered[f];
				if(!self._m_is_assigned(m)){
					to_reassign.push(m);
				}
			}
			var available = [];
			self._each_allocated(function(item, m, d){
				var ai = self.assigned[d];

				if((typeof ai.model_idx === 'undefined') || (ai.model_idx === null)){ console.warn('scroll: TODO error iterating over self.assigned. d=', d, ' ai=', ai, ' n_assigned=', self.assigned.length); return; }

				if(ai.filtered_idx < visible_results.first || ai.filtered_idx > visible_results.last || item.filter_pass !== true){
					//var item = self.items[ai.model_idx];
					//console.log('  available: ' + d + ': ' + item.name + ' row=' + (parseInt(ai.dom.css('top')) / (self.item_height + self.padding.y)) + ' filtered_idx=' + ai.filtered_idx + ' before=' + (ai.filtered_idx < visible_results.first) + ' after=' + (ai.model_idx > visible_results.last));
					available.push(d);
				}
			});
			if(to_reassign.length > available.length) console.warn('not enough available elements');
			for(var i in to_reassign){
				if(i < available.length){
					self._assign(available[i], to_reassign[i]);
				}
			}

			//console.log('thumbs.scroll: ' + parseInt(top, 10) + ' visible: ' + visible_results.first + ' --> ' + visible_results.last + ' to_reassign=' + to_reassign.length + ' available=' + available.length);
			if(false && to_reassign.length){
				setTimeout(function(){
					for(var d in self.assigned){
						var ai = self.assigned[d];
						console.log('  ' + d + ': ' + ai.model_idx + ': x=' + ai.position.left + ' y=' + ai.position.top + ' ' + ai.dom.find('img').length);
					}
				}, 1000);
			}

			$.ui.viewBase.prototype.scroll.apply(self, arguments);
		});
	},

	/*
	_find_first_result: function() {
		// return the lowest result index that has a dom element.
		var self = this;

		var first = 1000;
		for(var d in self.assigned){
			first = Math.min(first, self.assigned[d].model_idx);
		}

		return first;
	},

	_find_bottom_model_idx: function() {
		//return the highest assigned model index.
		var self = this;

		var max = 0;
		for(var i in self.assigned){
			var ai = self.assigned[i];
			if(ai.model_idx > max) max = ai.model_idx;
		}
		return max;
	},
	*/

	/*
	_find_bottom_element_idx: function() {
		// return the index for the dom element that is positioned at the bottom.
		var self = this, o = this.options;

		var i_bottom;
		var max = 0;
		for(var i in self.assigned){
			var ai = self.assigned[i];
			var top = ai.position.top;
			if(top >= max) i_bottom = i; // if multiple items are the same, we take the last.
			max = Math.max(max, top);
		}
		console.log('        bottom_element=' + i_bottom);
		return i_bottom;
	},

	_find_top_element_idx: function() {
		// return the index for the dom element that is positioned at the top.
		var self = this;

		var top_item;
		var min = 1000000;
		for(var i in self.assigned){
			var y = self.assigned[i].position.top;
			if(y < min) top_item = i;
			min = Math.min(min, y);
		}
		return top_item;
	},
	*/

	// should not be called directly: call grid._update({sizing: true}) instead
	resize: function() {
		var self = this, o = self.options;

		if(!self.element.is(':visible') && !o.grid.options.size_fits_content) return;
		self._old_n_visible_items = self.cache.n_cells;
		var old_n_columns = self.n_columns;

		var container_size = {width: self.element.parent().width(), height: self.element.parent().height()};

		self.n_columns = Math.floor(container_size.width / (self.item_width + self.padding.x));

		if(!self.n_columns) self.n_columns = 5, (window.is_node || console.warn('failed to calculate number of columns'));

		//how many items can we fit?
		self.cache.n_cells = self.n_columns * (Math.round(container_size.height / (self.item_height + self.padding.y)) + settings.overscan);

		if((self.n_columns !== old_n_columns) || (self.cache.n_cells !== self._old_n_visible_items)){
			//console.log('thumbs._resize: need re-layout: height=' + container_size.height + ' n_visible=' + self.cache.n_cells);
			self.__post_resize_assignment();
			o.products.have.filtering.done(function(){
				self._assign_fresh();
				self._set_scrollbar_size();
			});
		}
	},

	_new_element: function(d) {
		return {};
	},

	_assign: function(dom_idx, model_idx) {
		var self = this, o = this.options;

		if(model_idx >= o.products.items.length) return;

		var ai = self.assigned[dom_idx];
		if(!ai){ console.warn('thumbs._assign'); ai = self.assigned[dom_idx] = new AssignedItem('thumbItem', self.item_options); }

		$.ui.viewBase.prototype._assign.apply(this, arguments);

		var filter_idx = self._get_filter_idx(model_idx); // TODO is this different to self.items[model_idx].filtered_idx as used above?
		var row = Math.floor(filter_idx / self.n_columns);
		var column = filter_idx % self.n_columns;
		//console.log('assign: ' + model_idx + ' -> ' + dom_idx + ' row=' + row + ' column=' + column + ' x=' + (column * (self.item_width + self.padding.x)) + ' y=' + (row * (self.item_height + self.padding.y)));
		ai.dom.css(ai.position = {
			top:  row * (self.item_height + self.padding.y),
			left: column * (self.item_width + self.padding.x),
			width: self.item_width,
			height: self.item_height
		});
	}
});

var settings = {
	overscan: 1   // assign extra rows to allow for scrolling. currently only helps when scrolling down, not up.
}

});
