/*
 *  Provides a jquery ui interface for displaying a css-defined image.
 *
 *  All css must be provided by the user.
 *  Ideally, only css classes from the Theming API should be used.
 */

define(['jquery', 'jquery-ui/widget', './icon.css'], function($) {

$.widget('ui.icon2', {

	options: {
		css_class: null
	},

	_init: function() {

		var self = this;
		var o = this.options;

		this.element.addClass('icon');

		this.setIcon(o.css_class);
	},

	destroy: function(){
		this.element.removeClass(this.css_class);
	},

	setIcon: function(icon){
		this._setOption('css_class', icon);
	},

	_setOption: function(key, value) {

		$.Widget.prototype._setOption.apply(this, arguments);

		switch (key) {
			case 'css_class':
				if(this.css_class) this.element.removeClass(this.css_class);
				if(value) this.element.addClass(value);
				this.css_class = value;
				break;
			default:
				break;
		}
	}
});

});
