/*
 *
 */

define(['jquery', 'jquery-ui/widget', 'tool-buttons/close', './index.css'], function($) {

$.widget('ui.inlineMessage', {

	options: {
		message: '',
		mode: ''
	},

	_init: function() {
		var self = this, o = this.options;

		var container = $('<div>', {'class': 'inline-message'})
			.attr('tabindex', -1)
			.prependTo(this.element)
			.focus();

		container.div('.float-right toolbar-container')
			.toolButton({
				tooltips: true,
				small: true,
				tools : [[
					['close', function(){
						container.empty();
						//self.destroy();
					}]
				]]})
			.find('.sprite').addClass('small-icon small-icon-circle-close').css('marginTop', -6);

		if(o.mode === 'warning'){
			container.div()
				.icon2({'css_class': 'ui-icon ui-icon-alert float-left'})
		}

		var div = $('<div>', {'class': 'content'}).html(o.message).appendTo(container);

		if(o.mode){
			div.addClass(o.mode);
		}

		container.keydown(function(event){
			switch (event.keyCode) {
				case $.ui.keyCode.ENTER:
					self.destroy();
					break;
				default:
					break;
			}
		});
	},

	enable: function() {
	},

	disable: function() {
	},

	destroy: function() {
		//TODO only destroy 1 message, not all.
	}
});

});
