/*
 *  InputFilter provides a text box that notifies the consumer when meaningful changes have been made.
 */
define(['jquery', 'jquery-ui/widget', './input_filter.css'], function($) {

$.widget('ui.inputFilter', {

	options: {
		label: '',
		placeholder: 'Show All',
		on_filter: function(text){}
	},

	_init: function() {
		var self = this, o = this.options;

		self._input = {
			wait: 0,
			text: ''
		}
		self.previous = null;

		if(__DEV__ && self.element[0].nodeName === 'INPUT') return console.warn('do not use inputFilter on an Input element'), this;

		self.element
			.addClass('thumbnail-list-filter')
			.text(o.label)
			.div('.search-icon').parent()
			.input({type: 'text', placeholder: o.placeholder})
				.keyup(function(){
					self._input.text = $.trim($(this).val());

					var apply_filter = $.throttle(1000, function(){
						o.on_filter(self._input.text);
					});

					function delay(){
						setTimeout(function(){
							if(self._input.text || (self._input.wait > 4)){
								self._input.wait = 0;
								if(self._input.text.toLowerCase() != self.previous){
									self.previous = self._input.text.toLowerCase();
									apply_filter();
								}
							}
							else{
								self._input.wait++;
								delay();
							}
						}, 400);
					}
					delay();
				});
	},

	text: function() {
		return this._input.text;
	},

	_destroy: function() {
		this.element.off().removeClass('thumbnail-list-filter');
	}
});

});
