/*
 *  A widget to measure the size of an unrendered element by drawing it outside of the visible screen area.
 *
 *  note: doesn't always work adequately due to possible css changes when reparenting.
 */
define(['jquery'], function($){

$.fn.measure = function(args){

	var options = $.extend({max_width: null}, args || {});

	var el = $(this[0]);

	var orig_location = el.parent();

	var container = $('<div style="position:absolute; top:-1000px; left:-200px; overflow:none;""/>').appendTo($('body')).append(el);
	el.css('height', 'auto').show();
	var content_width = el.outerWidth();
	var content_height = el.outerHeight();

	//if too wide, render again with width constraint
	if(options.max_width && content_width > options.max_width){
		container.css({width: options.max_width});
		content_width = el.outerWidth();
		content_height = el.outerHeight();
	}

	orig_location.append(el);
	container.remove();
	return {height: content_height, width: content_width};
};

});
