
	$(document).ready(function(){
		function Notifier() {}
		 
		// Request permission for this page to send notifications. If allowed,
		// calls function "cb" with "true" as the first argument.
		Notifier.prototype.RequestPermission = function(cb) {
			window.webkitNotifications.requestPermission(function() {
				if (cb) { cb(window.webkitNotifications.checkPermission() == 0); }
			});
		}

		// Popup a notification with icon, title, and body. Returns false if
		// permission was not granted.
		Notifier.prototype.Notify = function(icon, title, body) {
			if (window.webkitNotifications.checkPermission() == 0) {
				var popup = window.webkitNotifications.createNotification(icon, title, body);
				popup.show();
				return true;
			}

			return false;
		}

		var el = $('#main-column');

		el.p('<b>Testing Webkit host notifications...</b>');

		if(window.webkitNotifications){
			var notifier = new Notifier();

			el.p('permission=' + (window.webkitNotifications.checkPermission() == 0));

			el.p('Requesting host notification permission...');

			notifier.RequestPermission(function(){
				el.p('got callback');
			});

			notifier.Notify('', 'title', 'body');
		}
		else el.p('Host notifications not available.');
	});
