require(['jquery', 'ajax_queue'], function($, Ajaxqueue) {

new Application(function () {
	var el = $('#content');
	var message_num = 1;

	new Test('test local story 1', el, function start(){
		var test = this;
		setTimeout(function(){
			$.notify({
				id: 1,
				story: 'test',
				title: 'Test Message 1',
				message: 'message1. This message should be red',
				kind: 'service-alert'
			});
		}, 500);

		setTimeout(function(){
			$.notify({
				id: 2,
				story: 'test',
				title: 'Test Message 2',
				message: 'message2. This message should have a blue background',
				kind: 'service-news'
			});
		}, 4000);

		setTimeout(function(){
			$.notify({
				id: 3,
				story: 'test',
				title: 'Test Message 3',
				message: 'Service all clear. This message should have a green background',
				kind: 'service-allclear'
			});

			setTimeout(function(){
				test.finished();
			}, 1000);

		}, 9000);
	});

	new Test('test local story 2', el, function start2(){
		// tests a story with 2 alerts

		var test = this;
		setTimeout(function(){
			$.notify({
				id: 1,
				story: 'test',
				title: 'Test Message 1',
				message: 'message1',
				kind: 'service-alert'
			});
		}, 500);

		setTimeout(function(){
			$.notify({
				id: 2,
				story: 'test',
				title: 'Test Message 2',
				message: 'Message 2. Service all clear. This message should have a green background',
				kind: 'service-allclear'
			});
		}, 4000);

		setTimeout(function(){
			$.notify({
				id: 3,
				story: 'test',
				title: 'Test Message 3',
				message: 'Service alert! This message should be red',
				kind: 'service-alert'
			});

			setTimeout(function(){
				test.finished();
			}, 1000);

		}, 9000);
	});

	new Test('test server notification', el, function start3(){
		var test = this;

		var kinds = ['service-notification', 'service-alert', 'service-news', 'service-allclear']

		var fnlist = [];
		for(var i = 0; i < kinds.length; i++) fnlist.push(function(done){
			var k = test.iter++;
			post_notification({
					title: 'Server Message ' + test.iter,
					message: 'message ' + (message_num++) + '. . . \n' + kinds[k],
					kind: kinds[k]
				},
				done
			);
		});

		test.series(fnlist);
	});

	function post_notification(msg, done){
		Ajaxqueue({
			url: ECMWF.options.ajax.add_notification,
			json: $.extend({
				title: 'Title',
				message: 'Message',
				kind: 'service-news',
				expires: 1000
			}, msg),
			success: function(){
				//TODO now wait for display
				setTimeout(function(){
					done();
				}, 3000);
			}
		});
	}
});

});
