/*
 *
 *  A dialogue window showing a chart.
 *
 *  Instantiate on the body element.
 */
define(['jquery', 'light_dialogue'], function($) {

var Preview = function(){$.widget('ui.preview', {

	options: {
		model: null
	},

	_init: function(args) {
		var self = this, o = self.options;

		self.el = self.element.find('> .preview')

		function set_content(){
			self.el.find('.description')
				.html(o.model.description || '&lt;no description&gt;')
				.each(function(){ $(this)[o.model.description ? 'show' : 'hide']() });
			self.keywords
				.html(o.model.keywords ? o.model.keywords() : '&lt;none&gt;')
				.each(function(){ $(this).parent()[$.trim($(this).text()) ? 'show' : 'hide'](); });

			o.model.load(function(url, error){
				self.el.find('.chart img').attr({src: url});
			});
		}

		if(self.el.length){
			set_content();
			self.open();
		}else{
			self.el = self.element.div('.preview').lightDialogue({title: o.model.title_()});

			setTimeout(function(){
				self.el.div('.description');
				self.el.div('.chart').img();
				self.keywords = self.el.div().p('keywords:').parent().div({className: 'keywords'});
				set_content();
			}, 200);
		}
	},

	destroy: function() {
		this.el.off().remove();
	},

	open: function() {
		this.el.css({visibility: 'visible'}).removeClass('fade-out').addClass('fade-in');
	},

	close: function() {
		this.el.removeClass('fade-in').addClass('fade-out').delayed(200, function(){ $(this).css({visibility: 'hidden'}); });
	}
})};

});
