/*
 *  'page level' package handler for the web (epsgram) package
 *
 */
define(['jquery', 'virtual-dom/h'], function($, h) {

	return {
		col1: function() {
			return [{
				name: 'history',
				title: 'Recently viewed',
				render: function(){
					var storage = is_wmo ? 'ensgram_history_wmo' : 'ensgram_history';
					epsgram_history = JSON.parse(localStorage[storage] || '[]');
					return h('ul.chart-history', $.map(epsgram_history, function(item){
						if(!item.values) item = item.product; // old format

						var name = item.values.station_name || item.values.meteogram_location;
						item = item.values;

						var location = (name || $.formatLatitude(item.lat, 1) + ' ' + $.formatLongitude(item.lon, 1)).replace('_', ' ');
						var time = new Time(item.time);
						var date = time.base_time.format('dd mmm HH:MM');
						var type = item.epsgram.replace('classical_', '');

						return h('li', {
							title: location + ' - ' + type + (date ? ' - ' + time.base_time.toString() : ''),
							onclick: function(e) {
								$(e.currentTarget).tipsy('hide');
								self._set_parameters(item);
							}}, [
								h('div', [h('div', [location])]),
								h('div', [h('div', [date])]),
								h('div.epsgram-type', [h('div', [type])])
							]
						);
					}))
				}
			}]
		},

		remove: function() {
		}
	}
});
