									// TODO remove user_info if menu is moved
define(
		['config', 'jquery', 'user_info', 'bus', 'chart-app/application', 'vgrid/products', 'product_browser/packages', 'vgrid/filters/text', 'vgrid/filters/facet', '../chart_handler', 'chart-app/router', 'mixins', 'page/query', 'element', 'vgrid', 'virtual-dom/h', 'vdom-virtualize', 'render-tree', 'facets', 'vgrid/input_filter', 'vgrid/button', 'app-menu', 'jquery-ui/button', 'throttle-debounce', 'messages', 'perfect-scrollbar', './view.css', '../product_browser.css', './tabs.css'],
		function(ECMWF, $, User, Bus, ChartApplication, products, packages, TextFilter, FacetFilter, CH, router, mixins, qs, DOM, VGrid, h, virtualise, RenderTree, Facets, InputFilter, Button, AppMenu) {

	var overlay = false; // config determining whether thumbnails are an overlay or main landing page content.
	var config = {
		show_view_buttons: false
	}

	var chart_handlers = CH;
	var page_handlers = {}; // these handlers manage chart-type differences that are outside the scope of chart widget plugins.

	var App = function(){};
	App.prototype = ChartApplication.default;

	var facet_filter = new FacetFilter()
	var n_filter_runs = 0;

	// this is intended to be refactored after we know what the menu contents are. It is shared with the tcyclone page
	function make_app_menu() {
		User.info.then(function(user) {
			var items = [
				// TODO links are better expressed as being relative to the application root
				{ title: 'View all',                      href: '/en/forecasts/charts/catalogue/' },
				{
					title: 'ENS Meteograms',
					items: [
						{ title: 'ENS meteograms',          href: '/en/forecasts/charts/web/classical_meteogram' },
						{ title: 'WMO ENS meteograms',      href: '/en/forecasts/charts/web/classical_meteogram_wmo' }
					]
				},
				{
					title: 'Cyclones',
					items: [
						{ title: 'Tropical cyclones',       href: '/en/forecasts/charts/tcyclone/' },
						{ title: 'Extra tropical cyclones', href: '/en/forecasts/charts/extra-tropical-cyclones' }
					]
				},
				{
					title: 'More charts',
					items: [
						{ title: 'Monitoring',              href: '/en/forecasts/charts/monitoring-observing-system/' },
						{ title: 'Ocean Reanalysis',        href: '/en/research/climate-reanalysis/ocean-reanalysis' },
						{ title: 'EUROSIP',                 href: '/en/forecasts/charts/seasonal/' }
					]
				}
			]

			var menu = new AppMenu({
				el: $('#app-menu .row'),
				items: items,
				help: [{
					name: 'help',
					title: 'Help',
					items: [
						{title: 'FAQ', href: '/search/faqs?f[0]=im_field_faq_category%3A1082'},
					]
				}]
			})
			menu.render();
		})
	}

	return $.extend(true, new App(), {
		config: {
			use_column_width: true
		},

		col1: function(o) {
			var self = this, w = this.widgets;

			// set this to have the product list sorted (can be used for grouping)
			//products.sort_by = 'title';

			App.prototype.col1.apply(this, arguments);

			// TODO find the best place to put this
			make_app_menu()

			/*
			this.have_url.done(function() {
				//path_filter.set([router.params.product_path]);
				self.update_category_links();
			});

			this.config.enable_hierarchy && (
				$.extend(self.widgets, {
					category_h2: o.el.h2('Categories'),
					path_links: o.el.ul('.path-links').text('Path links')
				})

				path_filter.events.bind('changed', function(path){
					console.log('-> path_filter changed', path ? path[0][0] : '');
					router.goto_list_page(path ? path[0][0].join('/') : (self._package || ''));
					self.update_category_links();
					self.scroll_to_col2();
				})
			);
			*/

			// delay left column rendering
			self.vdom.l.ready = [
				packages.get(self._package),
				products.have.filtering
			]

			packages.get(self._package).then(function(pkg){
				var button = new Button({
					icon: 'ui-icon-arrowthick-1-w',
					text: pkg.title,
					show_text: true,
					icon_position: 'left',
					className: 'col1-left-button',
					on_click: function() {
						router.add_state().goto_list_page();
					}
				})

				self.vdom.l.sections.push({
					name: 'navigation',
					render: function() {
						return [
							button.render()
						]
					}
				})
			})

			products.have.filtering.then(function() {
				var vgrid = new VGrid({
					products: products,
					renderer: self.vdom.l,
					view_mode: 'details',
					height: 700,
					enable_search: false,
					on_click: self.bind(self._on_thumbnail_click),
				})

				self.vdom.l.sections.push({
					name: 'results',
					title: 'Results',
					enabled: self._package !== 'web',
					hidden: self.is_landing_page,
					render: function() {
						return [
							vgrid.render()
						]
					}
				})
			})

			self.on.url.subscribe(function(changed) {
				if(changed.is_landing_page){
					packages.get(self._package).then(function(pkg){
						var left = self.vdom.l;
						$.each(['filters', 'navigation', 'results'], function(i, v){
							var s = $.findWhere(left.sections, {name: v});
							if(s) s.hidden = i ? self.is_landing_page : !self.is_landing_page
						})
						left.render()
					})
				}
			})

			facet_filter.events.bind('changed', function() {
				if(self._package && facet_filter._active){
					router.q.facets = facet_filter.to_url().facets
				}
			});
		},

		col2: function(o) {
			var self = this, w = this.widgets;

			App.prototype.col2.apply(this, arguments);

			if(false)
			(this.login_box = o.el.div('.login-message')).messages({messageBus: self.login_box.messageBus(), enable_popup: true, message_class: 'col-2-message'});

			products.selection.always = false;
			products.set_list();
			products.add_filters([/*TypeFilter,*/ new TextFilter(), facet_filter])

			self.vdom.l.filters.unshift(new InputFilter({
				on_filter: function(text){
					products.lookup_filter_by_name('text').enable().on_change(null, text);
				}
			}))

			var ready1 = new $.Deferred()
			products.have.filtering.then(function() {

				var vdom = new RenderTree({
					root: w.col2.content[0],
					tree: virtualise(w.col2.content[0]),
					main: {
						render: function() {
							return h('.panel-content', [vgrid.render()])
						}
					},
					ready: [ready1]
				})

				var vgrid = new VGrid({
					view_mode: 'simple',
					renderer: vdom,
					products: products,
					enable_search: false,
					on_click: self.bind(self._on_thumbnail_click),
					on_middle_click: function(item) {
						window.open(item.name() + (router._path.q || ''), '_blank');
					}
				})

				products.subscribe(self, vdom.bind(vdom.render));
				if(products.filtered) ready1.resolve()

				w.grid = o.el.find('.panel-content')
			})

			products.subscribe(function(){
				var left = self.vdom.l;

				ready1.resolve()

				if(w.facets && products.lookup_filter_by_name('facets')){
					if(!facet_filter.status()) w.facets.clear();
					w.facets.on_filter_change(); // the facets widget doesnt know about the filter list so the change handler is triggered manually
				}

				w.package_select && w.package_select.on_filter_change();

				// filter changes have no impact on history state unless the view is changed from product to listing.
				n_filter_runs && self.col2.css.left && router.add_state();

				self.on_filter_change();

				self._on_resize();
				// TODO layout sometimes happens before grid-items height is being set.
				setTimeout(self.bind(self._on_resize), 1000);

				n_filter_runs++;
			});

			products.on.items.subscribe(function() {
				window.is_node || console.log('%cpackage change:', 'background-color:#ff9', products.query.package);

				var results = $.findWhere(self.vdom.l.sections, {name: 'results'});
				if(results) results.enabled = products.query.package !== 'web'

				packages.get(self._package).then(function(pkg){
					$.each(page_handlers, function(i, v) {
						if(i === 'epsgram'){
							v.remove()
						}
					})

					products.sorted_facets(pkg, ['Product group'], function(fc) {
						self.vdom.l.filters.push(w.facets = new Facets({
							renderer: self.vdom.l,
							products: products,
							facets: fc,
							selection: (function() {
								var r = {}, facet;

								var pkg = products.query.package;
								if(router._path.q){
									var args = qs.parse(router._path.q.slice(1));
									if(args.facets){
										facet = args.facets;
									}
								}
								// example url query: ?facets=Product group,Basic EFI;Component,Atmosphere,Geography
								if(facet){
									var facets = facet.split(';');
									$.each(facets, function(i, v) {
										var f = v.split(',');
										if(f.length > 1){
											r[f.shift()] = $.map(f, function(v, i) { return $.trim(v); });
										}
									});
								}
								router.add_parameter('facets');
								return r;
							})(),
							on_change: function(a, b, val, user_initiated) {
								facet_filter.set([a, b], val);
							}
						}));
					})
				})

				// navigation
				/* -- links have now moved to the application-bar
				products.packages.then(function(pkgs) {
					var p = $.findWhere(pkgs, {name: products.query.package});
					if(p){ // TODO to be consistent, the section should always be present, but empty if there are no links
						p.links && self.vdom.l.sections.unshift({
							name: 'links',
							render: function() {
								return [h('ul.menu', $.map(p.links, function(v){ return h('li.menu__item.is-leaf.leaf', [h('a', {href: v.url}, v.title)]) }))];
							}
						})
						packages.get(self._package).then(self.vdom.l.bind(self.vdom.l.render))
					}
				});
				*/
			});

			CH.product_change.subscribe(function() {
			});

			/*
			products.selection.subscribe(function() {
				// -as much as we would like, this cannot be the main handler because we do not get clicks on an already-selected product.
			});
			*/

			o.el.show();

			this.col2.css = {}
			this.col3.css = {};

			__HAVE_APPMENU__ ||
			this._package && packages.get(this._package).then(function(pkg){
				setTimeout(function(){
					if(pkg && pkg.additional_links && pkg.additional_links.length){
						var div = w.col2.find('> .additional-links').orelse(function(){
							var div = w.col2.div('.additional-links')
							div.h3('Additional charts');
							div.ul();
							return div;
						});
						var ul = div.find('> ul');
						$.each(pkg.additional_links, function(i, v) {
							var external = v.url.indexOf(router.base_path) !== 0;
							var a = ul.li().a({href: v.url.replace('@BACKEND', '//' + ECMWF.options.backend_host), rel: external ? 'external' : ''});
							a.img({src: v.thumbnail.replace('@BACKEND', '//' + ECMWF.options.backend_host)});
							a.div('.title').text(v.title);
						});
						self._on_resize();
					}
				}, 3000)
			});
		},

		col3: function(o) {
			var self = this;
			var panel = this.col3;
			panel.widgets = {results: {}};

			App.prototype.col3.apply(this, arguments);

			//o.el.show(); - dont show too early
			//this.col3.size = {width: 400, height: 400};

			delete this.col3.css.height;

			//this.size_override_targets = $('.top-bar #main').orelse(function(){ return $('#centred, #top, #footer > div'); }); // www vs apps

			Bus()
				.listen('chart-added', function() {
					CH.widgets.chart.messageBus().listen('chart-product-availability', function(_, msg) {
						if(msg.valid_time.values.length > 1){
							self._on_resize();
						}
					});
				})
				// TODO there is a better way than forwarding global to local bus?
				.listen('prev-step', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('prev-step');
				})
				.listen('next-step', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('next-step');
				/*
				})
				.listen('tool-animation-toggle', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('tool-animation-toggle');
				*/
				});

			$.extend(this.widgets, {
				chart_container: o.el.find('> .chart-container').orelse(function(){ return o.el.div('.chart-container') }), // with interactive charts, the container is the width of the chart but the column is wide enough to fill all the available space
				legend: o.el.find('#chart-legends').orelse(function(){ return o.el.div('#chart-legends'); }).hide(),
				content: o.el.find('.product-text').orelse(function(){ return o.el.div('.product-text text-content'); })
			})

			{ // change the dom layout to be a 2 row table - TODO modify the template
				var parent = $('.column-1').parent()
				var mainrow = parent.parent().find('.main-row').orelse(function() {
					return parent.div('.main-row')
				})
				parent.find('.title-row').orelse(function() {
					$('.column-1, .column-2, .chart-column').prependTo(mainrow)
				})
			}

			this.have_chart.done(function() {
				var results = panel.widgets.results;

				$('body').off('click', close).click(close);

				function close() {
					results.menu && results.menu.hide();
				}
			});

			/*
			chart_handlers.on.size_change = function(size) {
				self._on_resize();
			}
			*/

			/*
			this.widgets.next = o.el.div('.button-next').click(function() {
				self.widgets.grid.grid('next');
			});
			*/
		},

		on_filter_change: function() {
		},

		_on_thumbnail_click: function(item) {
			if((!router._path.page) || item !== CH.state.list_product){
				router.add_state();

				if(item === CH.state.list_product){
					// the selected product is the same as the previous product
					router.set_product(item.name(), item.title_());
				}else{
					// In this case, the page status is updated via the chart_handler.
					// This is wrong but fixing it requires the chart controls to be decoupled from the chart widget.

					var chart;
					if((chart = CH.widgets.chart && CH.widgets.chart.data('ui-basicChart'))){
						chart.grey();
					}
					this.on_product_select(item);
				}
			}
		},

		scroll_to_col2: function() {
			this.widgets.col2.show();
			this.widgets.col3.hide();
		},

		scroll_to_col3: function() {
			setTimeout(function() {
				if($(document).scrollTop() > 500){
					$(document).scrollTop($('h1').offset().top - 10)
				}
			}, 1000)

			this.widgets.col2.hide();
			this.widgets.col3.show();
		},

		q_size: function() {
			var width = parseInt($('.chart-container .chart').css('min-width'));
			return {
				width: width,
				height: Math.round(width * (width === 1280 ? 0.5625 : 0.667))
			}
		},

		on_product_select: function(product, params) {
			var self = this;

			App.prototype.on_product_select.apply(this, arguments);

			this.scroll_to_col3();

			if(CH.state.list_product === product) return;
			CH.set_state({list_product: product});

			var is_interactive = !!~$.inArray('interactive', product.data.widgets);
			var chart_type = is_interactive ? 'interactive' : 'basic';

			var handler = chart_handlers[chart_type];
			handler.host = this;
			if(handler !== chart_handlers.current){
				var size;
				if(is_interactive){
					if(!this.widgets.chart_container.find('.chart').length) this.widgets.chart_container.div('.chart'); // this div is needed to when using css media-queries to specify chart size
					size = self.q_size();
				}

				// 'current' is now set earlier to ensure that it is always set before listeners run.
				// (different require implements have varying amounts of asynchronicity)
				var old_handler = chart_handlers.current;
				chart_handlers.current = handler;

				old_handler && old_handler.cleanup();
				handler.build(product, params || (old_handler && old_handler.state), {el: this.widgets.chart_container, size: size}, function() {
					CH.widgets.chart.messageBus()
						.listen('size-changed', function(_, size) {
							self._on_resize(size);
						})
						.listen('chart-content-update', function(_, msg) {
							self._on_resize();
						})
						.listen('chart-legend-loaded', function() {
							// not needed now?
							//self._on_resize();
						});

					$('body').off('layout.viewer').on('layout.viewer', function() {
						if(is_interactive){
							var size = self.q_size();
							if(size.width !== CH.widgets.chart.width() || size.height !== CH.widgets.chart.height()){
																																console.log('view:         got layout event: size=', size);
								self.widgets.chart_container.css({width: size.width}).attr({sizor: 'view.layout'});

								CH.widgets.chart
									.css(size).attr({sizor: 'view.on-layout'})
									.chart('instance').resize(size);
							}
							// sizing time navigator even if size hasnt changed due to intemittent issues (perhaps not done first time)
							CH.widgets.time_navigator.timeNavigator('instance').resize({width: size.width});

							self._on_resize();
						}
					});

					$.each(['legend', 'content', 'next'], function(i, v) {
						self.widgets[v] && self.widgets[v].appendTo(self.widgets.col3);
					});

					// update page-level handlers for different chart types
					$.each($.extend({}, page_handlers), function(name, v) {
						for(var i in v.widgets){
							if(!~$.inArray(v.widgets[i], product.data.widgets)){
								v.remove && v.remove()
								delete page_handlers[name]
							}
						}
					});
					$.each(product.data.widgets, function(i, v) {
						if(!!~$.inArray(v, ['epsgram'])){
							if(!~$.inArray(v, page_handlers)){
								var A
								switch(v){
									case 'epsgram':
										A = require('../handlers/epsgram')
								}
								var handler = page_handlers[v] = new A(self)
								if(handler.col1){
									$.merge(self.vdom.l.sections, handler.col1())
								}
							}
						}
					})
				});
			}else{
				handler.update(product);
			}

			var navigation = $.findWhere(self.vdom.l.sections, {name: 'navigation'});
			if(navigation) navigation.hidden = !!~$.inArray('epsgram', product.data.widgets)
		},

		// do not call directly, call _on_resize
		_do_layout: window.is_node ? $.noop : function() {
			// TODO column_padding
			// TODO borderx - does not work for sites that have variable border size
			var self = this, col2 = self.widgets.col2, col3 = self.widgets.col3, column_padding = 50, window_width = $(window).width();

			(this.widgets.time_navigator && this.widgets.time_navigator.length) || (this.widgets.time_navigator = $('#time-navigator, .time-nav'));

			// Set the size of the chart container
			// -the chart container allows items associated with the chart such as the time navigator to be the same width
			// -the chart container is the same width as the chart and is usually smaller than the chart column.
			if(!this.is_landing_page) {
				switch(CH.current){
					case CH.basic:
						__DEV__ && console.log('___ layout: is basic');
						self.widgets.chart_container.css({width: ''}).attr({sizor: ''});
						break;
					case CH.interactive:
						if(CH.widgets.chart){
							/*
							 *  There is quite a tricky problem here
							 *  We need to know how big to make the chart
							 *  To do that we need to find out somehow from the browser how much space is available.
							 *
							 *  Possibilities:
							 *    1- measure the chart or its container - this does not work when reducing size because the chart is intentionally making the page wider
							 *    2- use a container that is not affected by chart size - this cannot work because it is intended that the page increases in width to accomodate the chart
							 *    3- measure the page width - this is error prone because of many variables for column widths and various margins and padding
							 *    4- specify a set of chart widths in css using media queries - this is conceptually similar to option 3 but may in practice be easier to manage
							 *       One advantage of media-queries is that it uses viewport size rather than body size
							 *       Beware in Firefox that the media-query size includes the scrollbar! (check)
							 */

							// TODO the chart width is not set here - is set in on.layout above which runs BEFORE this - should we move this stuff there?

							//var width = col3.find('.chart-image').width();
							/*
							var width = parseInt($('.chart-container .chart').css('min-width'));
							__DEV__ && console.log('___ layout: imagesize=', width, 'minwidth=', parseInt($('.chart-container .chart').css('min-width')))
							// it appears that unless the width is specifically set on the chart-container, the browser will render it too wide
							self.widgets.chart_container.css({width: width}).attr({sizor: 'view.layout'});
							//CH.widgets.chart.chart('instance').resize({width: width})
							CH.widgets.time_navigator.find('.time-nav').triggerHandler('layout', {width: width});
							*/
						}
						break;
				}
			}

			if(!__WIDGET__){
				var col1_width = this._col1_width();
				var left_width = col1_width + (col1_width ? column_padding : 0);

				var r_col_normal_width = this.config.use_column_width
					? window_width - col1_width - 2 * self.config.page.borderx - column_padding
					: 0; // ignore the column width, just use the chart width
				var is_interactive = !!~$.inArray('interactive', CH.state.list_product && CH.state.list_product.data.widgets);
				self.col2.css.width = window_width - col1_width - 2 * self.config.page.borderx - column_padding;

				if(this.is_landing_page){
					this.col2.css.width = r_col_normal_width
				}
			}

			if(this.is_landing_page) self.scroll_to_col2(); else self.scroll_to_col3();

			$.each(page_handlers, function(i, v) {
				v.layout && v.layout();
			});

			//this.widgets.time_navigator.triggerHandler('layout', {width: this.widgets.time_navigator.width()});
		},

		on_url_change: function(ctx) {
			var self = this;

			App.prototype.on_url_change.apply(this, arguments);

			if(self.is_landing_page){
				products.have.items.then(function(items) {
					self.h1(products.hierarchy.lookup(router._path.dir).title);
				});
				//products.thumbnail_priority = 'high' // blocks text content
			}else{
				self.have_chart.done(function() {
					setTimeout(function() { // timeout added because sometimes during a product change this is being called before CH.state is updated. TODO simplify changes so that all changes go via the Router.
						self.h1(CH.state.list_product.long_title());
					}, 0);
				});
				//products.thumbnail_priority = 'low'

				// temporary - resizes are being missed so this adds extra timenavigator resizes even when not needed
				setTimeout(function() {
					if($('.chart-column .chart:visible').length === 1){
						CH.widgets.time_navigator && CH.widgets.time_navigator.timeNavigator('instance').resize({width: CH.widgets.time_navigator.width()});
					}
				}, 2000)
			}
		},

		/*
		update_category_links: function() {
			var self = this;

			this.config.enable_hierarchy && products.products().then(function(items) {
				var children = products.hierarchy.children(router.params.product_path);
				self.widgets.path_links.empty();
				for(var c in children){
					var child = children[c];
					self.widgets.path_links.li().a({href: child.name + '/'}).text(child.title).click(function() {
						console.log('category.click: child=', $(this).attr('href'));
						path_filter.set_child($(this).attr('href').replace('/', ''));
						return false;
					});
				}
				self.widgets.category_h2.text(ECMWF.ucfirst(router.params.product_path[router.params.product_path.length - 1].replace(/-/g, ' ')));

				self.widgets.path_links.add(self.widgets.category_h2)[(!children) || $.isEmptyObject(children) ? 'hide' : 'show']();
			});
		}
		*/
	});
});
