define(['config', 'jquery', 'bus', 'ajax_queue'], function(ECMWF, $, Bus, Ajaxqueue){

return productManager = function(args){

	var bus = Bus();

	var types = ['product', 'projection', 'layer'];
	for(var t in types) add_listener();

	function add_listener(){
			var kind = types[t];

			bus
				.listen(kind + '-thumbnail-delete', function(_, msg){
					msg.type = kind;

					Ajaxqueue({
						url: '/backend/delete-from-user-space/',
						priority: "very-high",
						json: msg,
						success: function(result){
							bus.send(kind + "-removed-from-catalogue", result)
						},
						error: function(result){
							$.logError(kind + " delete failed.");
						}
					});
				})

				.listen(kind + "-thumbnail-edit", function(_, msg){
					ECMWF.dialogue({
						title: "Edition options  ...",
						items: [{
							type: "string",
							name: "title",
							value: msg.title,
							title: "Name"
						}, {
							type: "text",
							name: "description",
							value: msg.description,
							title: 'Description'
						}, {
							type: 'text',
							name: 'keywords',
							value: msg.keywords,
							title: 'Keywords'
						}],
						ok: function(choices){
							choices.type = kind;
							choices.name = msg.name;
							Ajaxqueue({
								url: '/backend/modify-information',
								priority: 'very-high',
								json: choices,
								success: function(result){
									bus.send(kind + '-modified-info', result)
								}
							});
						}
					});
				});
	}
};

});
