define(['jquery'], function($) {

$.fn.selectImage = function(options){
    this.each(function(){
        var elem = $(this);
        elem.addClass("select-image");

        var div = $("<div/>").hide().addClass("select-image-list").css({
            position: "absolute",
            overflow: "auto"
        }).appendTo(elem.parent());

        var layer = $("<div/>").css({
            position: "relative",
            /* border : "1px solid pink", */
            // Tranparent pixel, needed by IE
            backgroundImage: "url('data:image/gif,GIF89a%01%00%01%00%80%00%00%FF%FF%FF%00%00%00!%F9%04%01%14%00%00%00%2C%00%00%00%00%01%00%01%00%00%02%02D%01%00%3B')"
        }).appendTo(elem.parent()).text(" ");

        var d = elem.dimensions();

        function position() {
            var p = elem.position();

            div.css({
                top: p.top + d.outerHeightWithMargins - 1,
                left: p.left,
                width: d.outerWidth - 2 // 2 = border
            });
            layer.css({
                top:     -d.outerHeight,
                width:    d.outerWidth,
                height:   d.outerHeight
            });
        }

        position();

        elem.find("option").each(function(){
            var opt = $(this);

            var d = $("<div/>").appendTo(div).click(function(){
                elem.val(opt.attr("value")).change();
            });

            var img = $("<img/>").appendTo($("<center/>").appendTo(d));

            //console.warn(options);

            if(options && options.default_src) {
                img.attr("src", options.default_src);
                setTimeout(function() { img.attr("src", opt.attr("title")); }, 100);
            }
            else {
                img.attr("src", opt.attr("title"));
            }

            opt.data("img", img);

            $("<span/>").text(opt.text()).appendTo(d);
        });

        elem.keydown(function(e){
            //position();
            e.stopImmediatePropagation();
            e.preventDefault();
            elem.blur();
            layer.click();
        });

        elem.click(function(e){
            //position();
            e.stopImmediatePropagation();
            e.preventDefault();
            elem.blur();
            layer.click();
        });

        layer.click(function(e){

            elem.blur();
            position();

            //e.preventDefault();

            if (div.is(":visible")) {
                div.hide();
                return false;
            }
            var v = elem.val();
            //var h = 0;
            elem.find("option").each(function(){
                var opt = $(this);
                // TODO: Find a better way..

                if (opt.attr("value") === v) {
                    setTimeout(function(){
                        div.scrollTo(opt.data("img"), {}).scrollTo('-=10px', {
                            axis: 'y'
                        });
                    }, 1);
                }

                opt.data("img").toggleClass("selected", opt.attr("value") === v);
            });

            //elem.blur();
            div.show();

            $(document).one("click", function(){
                div.hide();
            });

            return false;
        });
    });

    return this;
};
});
