define(['jquery', 'bus'], function($, Bus){

var items = [];

$.fn.shortcuts = function(args){

	var options = $.extend({}, args || {});

	var el = $(this[0]);
	if(__DEV__ && this[0] != document) console.log('shortcuts widget would normally be used on the Document object');

	if(!items.length){
		el.keydown(function(event) {

			var inputs = ['INPUT', 'TEXTAREA'];
			if((event.originalTarget && ($.inArray(event.originalTarget.nodeName, inputs) != -1))  //gecko old
				|| (event.target && ($.inArray(event.target.nodeName, inputs) != -1))               //gecko new
				|| (event.srcElement && ($.inArray(event.srcElement.nodeName, inputs) != -1))       //webkit
			){
				if(!event.altKey && !event.ctrlKey && !event.metaKey) return; //no modifier keys pressed. Allow the Input element to handle events.
			}

			for(var i in items){
				var item = items[i];
				if(event.keyCode === item.key){
					if(item.keydown) item.keydown();
					if(item.signal) (item.messageBus || Bus()).send(item.signal);
					if(item.callback) item.callback();
				}
			}
		});
	}

	if(!options.shortcuts) options.shortcuts = [args];

	$.each(options.shortcuts, function(){ items.push(this); });

	return this;
};

});

