import $ from 'jquery'
import './collapse'

(function() {
    'use strict';

    $(function() {
        exclusiveHeaderMenu();
        triggerOverlayClick();
        resetWithEscKey();
    });

    /* On resize. */
    $(window).resize(function(){
        resetHeaderNav();
    });

    /* Make menus exclusive and show/hide overlay. */
    function exclusiveHeaderMenu() {

        $('.navbar-toggle').on('click', function(){
            var id = $(this).attr('id');
            var target = $(this).data('target');
            // Add "active" class to clicked element.
            $(this).toggleClass('active');
            // Remove "active" class from other elements.
            $('.navbar-toggle:not(#' + id + ')').removeClass('active');
            // Close other menus.
            $('.header-menu:not(' + target + ')').collapse('hide');

            // Check if clicked element is "active".
            if ($(this).hasClass('active')) 
            {
                // Hide grey overlay if all menu are closed.
                $('.menu-collapse-overlay').fadeIn('fast');
            }
            else
            {
                // Display grey overlay if a menu is open.
                $('.menu-collapse-overlay').fadeOut('fast');                
            }
        });
    }

    /* Reset menu with Esc key. */
    function resetWithEscKey()
    {
        $(document).keyup(function(e) {
             if (e.keyCode == 27) {
                resetHeaderNav();
            }
        });
    }

    /* Reset elements on screen resize. */
    function resetHeaderNav()
    {
        if (screen.width > 768)
        {
            $('.navbar-collapse').collapse('hide');
            $('.navbar-toggle').removeClass('active');
            $('.header-menu.collapse.in').collapse('hide');
            $('.menu-collapse-overlay').fadeOut('fast');
        }
    }

    /* Close sub nav when click overlay. */
    function triggerOverlayClick()
    {
        $('.menu-collapse-overlay').on('click', function(){
            $('.header-menu.collapse.in').collapse('hide');
            $('.navbar-toggle').removeClass('active');
            $('.menu-collapse-overlay').fadeOut('fast');
        });
    }

})()
