/*
 *  Add the username in the page header
 *
 *  Note that this does NOT display an error message for pages that require a login.
 */

define(['config', 'jquery', 'user_info'], function(ECMWF, $, User) {

	$(function(){
		User.info.then(function(user) {
			// Fetch user information via ajax.
			$('#header-user a[href="/auth/login/"]').each(function() {
				if(user.user_name){
					$('#header-user .user-name').text(user.user_name);
					$('#header-user .btn-group').show();
					$('#header-user > li > a:eq(1)').hide();
				}else{
					__DEV__ && console.log('user not logged in');
					ECMWF.options.backend_host && $('.not-logged-in a').attr({href: '//' + ECMWF.options.backend_host + '/auth/login/?back=' + encodeURIComponent(location.href)})
				}
			})
		})
	})
})
