define(['config', 'jquery', 'utils', 'ajax_queue'], function(ECMWF, $, Utils, Ajaxqueue){

$.fn.thumbnail = function(_o){
	var o = $.extend({
		kind: 'product',
		name: null,
		size: null,
		tag: undefined,
		load: false,
		loaded: $.noop,
		click: $.noop,
		dblclick: $.noop
	}, _o);

	return this.each(function(){
		$(this).addClass('thumbnail');

		var img = $('<img/>', {
				alt  : o.title,
				title: o.description
				//src  : o.size ? '' : ECMWF.options.files['default_' + o.kind + '_thumbnail']
			})
			.addClass('thumbnail-img')
			.prependTo($(this))
			.click(function(){ o.click(); })
			.dblclick(function(){ o.dblclick(); })

		/*
		 *   One of two possible backend calls is used. If the size is specified, get_chart is used, otherwise product_thumbnail
		 */
		o.load && Ajaxqueue(
			o.size ? {
				url        : ECMWF.options.ajax.backend.get_chart,
				json: {
					product: $.extend({availability: true, viewport: o.size}, o.product.state || {product: o.product}),
					animate: null
				},
				priority   : 'normal',
				img        : img,
				cache      : 30,
				tag        : o.tag,
				logErrors  : 'Get ' + o.kind + ' thumbail (' +  (o.title ? o.title : o.name) + ')',
				success: function (json) {
					if(json){
						o.loaded(json.result.url);
					}
				},
				error : function() {
					img.css({height: 'auto', width: 'auto'}).attr('src', Utils.blank_gif);
				}
			} : {
				url        : '/backend/' + o.kind + '-thumbnail/' + o.name + '/',
				tag        : o.tag,
				priority   : 'normal',
				cache      : 30,
				logErrors  : 'Get ' + o.kind + ' thumbail (' +  (o.title ? o.title : o.name) + ')',
				success: function (json) {
					if(!json) return;

					img.css({ height: 'auto', width: 'auto'}).attr('src', json.url);
					//item.done = true;
					o.loaded(json.url);
				},
				error : function() {
					img.css({height: 'auto', width: 'auto'}).attr('src', Utils.blank_gif);
				}
			}
		);
	});
};

});
