define(['jquery', 'bus', 'settings'], function($, Bus, Settings) {

	$.Tool = function(name, toolbar, args) {
		var self = this;

		this.callback = args.callback;
		this.settings = args.settings || false;
		this.selectable = args.selectable || this.settings;
		this.tip = args.tip || '';

		this.selected = false;

		if(this.settings){
			if(Settings.get(name) !== false){
				setTimeout(function(){
					Bus().send('tool-select', name);
				}, 2000);
			}
		}

		this.destroy = $.noop;

		this.name = function () {
			return name;
		};

		this.tool_tip = function() {
			return $.isFunction(self.tip) ? self.tip() : self.tip;
		};

		this.click = function(event, message_bus) {
			console.log('Tool.click');
			if(self.callback) self.callback();
			Settings.set(name, self.selected);
			message_bus.send('tool-' + name + '-click', self.selected);
		};
	};

	return $.Tool
});
