import Toolbar from 'toolbar'
import Bus from 'bus'
import Undo from 'undo'

var name = 'undo';

function Tool(toolbar) {

	function enable(_, msg) {
		if(msg.undo) {
			toolbar.enable(name);
		} else {
			toolbar.disable(name);
		}
	}

	Bus().listen('undo-list-changed', enable);

	this.destroy = function () {
		Bus().forget('undo-list-changed', enable);
	}

	this.name = function () {
		return name;
	}

	this.tool_tip = function() {
		return 'Undo';
	}

	this.click = function(event, message_bus ) {
		Undo.last();
	}

	this.disabled = true;
}

Toolbar.register(name, function(toolbar) { return new Tool(toolbar) });
