
// simple text match filter

define(['../filter', 'utils'], function(Filter, Utils){

	function TextFilter() {
		this.regex = null;
		this.name = 'text'

		this.fn = function(item){
			return (!this.regex || item.title_().match(this.regex) || item.name().match(this.regex) || item.keywords().match(this.regex));
		}

		this.on_change = function(a, val){
			this.text = val;
			this.regex = new RegExp(Utils.escape_regex(val), 'i');
			this.events.send('changed');
		}

		//TODO we need this method? set empty value instead?
		this.deactivate = function() {
			this.text = '';
			this.regex = null;
			this.events.send('changed');
		}

		this.status = function(){ return this.text; },

		this.text = null
	}
	TextFilter.prototype = new Filter();

	return TextFilter;
});
