/*
 *  TODO
 *    - clean out code that is no longer used
 */
define(['jquery', 'ajax_queue', 'utils', 'virtual-dom/h', 'chart-app/router', './base', 'perfect-scrollbar/perfect-scrollbar.css'], function($, Ajaxqueue, Utils, h, page, ViewBase){

var show_title = true;
var img_data = {}

var VGridGroupsView = function(options){
	this.create(options)
}

VGridGroupsView.prototype = $.extend({}, ViewBase, {

	create: function(options) {
		this.options = $.extend({
			products: null,
			width: 600,
			height: 400,
			scrollbar: null
		}, options);

		ViewBase.create.apply(this, arguments);

		var self = this, o = this.options;

		this.item_height = 80 + (show_title ? 38 : 0);
		this.item_width = 127;
		this.padding = {x: 8, y: 16};
		this.overscan = 2;            // assign extra rows to allow for scrolling. currently only helps when scrolling down, not up.
		this.n_columns = 0;
		this.group_label_height = 34;

		show_title && (this.item_options.show_title = true);

		o.scrollbar.state.inner_height = 20 // TODO

		o.renderer.on.render.once(function(){
			// TODO move part of this.render here
		})

		if(__DEV__){
			this.debug_status = function() {
				var root = $(self.options.renderer.root)
				if(root.is(':visible')){
					console.log('grid status:')
					console.log('    products:', o.products.filtered.length, o.products.items.length)
					console.log('    height:', root.find('.catalogue-grid').height())

					var n = 0, ng = 0;
					self._results_by_group_all(
						function(group){ ng++ },
						function(item, i, ig, gr){ n++ }
					);
					console.log('    rendered: products=', n, 'groups', ng, ' dom=', root.find('.catalogue-grid .item').length)
					console.log('    columns:', self.n_columns)
				}
			}

			//setTimeout(function() { self.debug_status() }, 6000)
		}
	},

	_assign_fresh: function() {
		// is called after resize (old api - needs updating)
		this._invalidate_positions();
		this._on_n_viewable_items_changed();
		this.have.assignment.resolve();
	},

	_invalidate_positions: function() {
		this._positions_valid = false;
	},

	_calc_positions: function() {
		// note we cannot use natural_height here as its calculation depends on the output of this method

		var self = this;

		if(__DEV__ && !self.n_columns) return console.log('calc_positions: size not set')

		this.groups_valid || this._update_groups();

		var label_height = (self.groups.length > 1) ? self.group_label_height : 0;

		var scrolltop = $(self.options.renderer.root).find('.scrollable').scrollTop();

		var found = false;
		var y = -(self.item_height + self.padding.y);
		self._results_by_group_all(
			function(group){
				y += self.item_height + self.padding.y;
				group.y = y;
			},
			function(item, i, ig, gr){
				y = gr.y + label_height + Math.floor((ig / self.n_columns)) * self.item_height;
				gr.height = label_height + Math.ceil(((ig + 1) / self.n_columns)) * self.item_height + self.padding.y;

				var overscan = self.overscan * self.item_height;
				var visible =
					(y > scrolltop - overscan) &&
					(y < scrolltop + self.options.height + overscan);

				if(!found && visible){
					found = true;
					self._first = i;
				}

				item[self.eventNamespace] = item[self.eventNamespace] || {};
				$.extend(item[self.eventNamespace], {
					ig: ig,
					y: y,
					visible: visible
				});
			}
		);
		this._positions_valid = true;
	},

	render: function() {
		var self = this, o = self.options, list = o.products, el = $(o.renderer.root);
		//console.log('%cgroups.render', 'background-color:#ff9')

		if(!list.filtered) return h('div')

		o.products.cancel_thumbnails();

		if(!self.scroll_handler){
			self.scroll_handler = el.on('vscroll', function() {
				self._invalidate_positions();
				self.options.on_needs_render();
			});
			// TODO do this in the scrollbar
			// TODO remove timeout
			setTimeout(function(){
				o.scrollbar.state.top = el.find('.scrollable').scrollTop();
				self.scrollable = el.find('.scrollable')
				self.scroll(self.scrollable.scrollTop());
			}, 1000);
		}

		this.groups_valid || this._update_groups();
		if(!self.n_columns) return h('div.grid-items.thumbs');
		this.natural_height()
		this._positions_valid || this._calc_positions();

		labels = [];
		items = [];
		var group_label_height = (self.groups.length > 1) ? self.group_label_height : 0;

		self._results_by_group(
			function(group){
				if(self.groups.length > 1){
					labels.push(h('h3', {
						style: {top: (group.y - 8) + 'px'},
						onclick: function(e){
							page.add_state();
							facets = list.lookup_filter_by_name('facets')
							facets && facets.set(['Product group', group.name], true)
							e.stopPropagation()
						}
					},
					[group.name]));
				}
			},
			function(item, m, d, ig, gr){
				var local = item[self.eventNamespace];

				var column = ig % self.n_columns;

				var url = img_data[item.name()] || item.cache.thumbnail.call(item); // cannot use the normal thumbnail method here because it is asynchronous

				var use_inline = o.products.kind === 'product' // TODO add backend projection-thumbnail-inline

				items.push(h('div.item.thumbnail-wrapper' + (local.selected ? '.selected' : ''), {style: {top: local.y + 'px', left: column * (self.item_width + self.padding.x) + 'px'}}, [
					h('div.thumbnail', [ use_inline ?
						h('img.thumbnail-img' + (item.thumbnail_error ? '.failed.ui-icon.ui-icon-alert' : ''), {
							alt  : item.title_(),
							title: self.megatooltips ? '' : $('<div>').html(item.data.description).text() || item.title_(),
							name : item.name(),
							src  : url || Utils.blank_gif,
							style: url || item.thumbnail_error
								? { visibility: 'visible', opacity: 1.0 }
								: { visibility: 'hidden', opacity: 0.0 }
						})
						:
						h('img.thumbnail-img', {
							alt  : item.title_(),
							title: $('<div>').html(item.data.description).text() || item.title_(),
							name : item.name(),
							src  : (url && (url !== 'validation failed')) ? url : Ajaxqueue.options.host + '/backend/get-thumbnail/' + o.products.kind + '/' + item.name() + '/'
						})
					]),
					h('div' + (show_title ? '.title' : '.hidden') + (item.has_widget('clickable') ? '.clickable' : ''), item.title_())
				]));

				use_inline && !url && !item.thumbnail_error && item.thumbnail && item.thumbnail({tag: item.name() + self.eventNamespace, priority: 'very-high'}, function(url, image, error){
					if(error){
						item.thumbnail_error = true;
					}else{
						if(!image) return;

						// we may have multiple callbacks from the same request, so img_data may already be set
						img_data[item.name()] = image;
					}
					self.options.on_needs_render();
				});
			}
		);

		items.push(h('div.group-labels', labels));

		var clicks = 0;

		function item_from_event(ev){
			var target = $(ev.target);
			return o.products.product_by_name(target.attr('name') || target.find('> img.thumbnail-img').attr('name'));
		}

		return h('div.grid-items.thumbs', {
			style: {height: (o.height ? this.natural_height() : 400) + 'px'},
			onclick: function(ev){
				if(++clicks === 1){
					setTimeout(function() {
						console.log('groups.click');
						var item = item_from_event(ev)
						item && clicks === 1 && o.click(item);
						clicks = 0;
					}, 300)
				}
			},
			ondblclick: function(ev){
				console.log('groups.dblclick');
				var item = item_from_event(ev)
				item && o.dblclick(item);
			}
		}, items);
	},

	select: function(item) {
		var self = this, o = this.options, list = o.products;

		list.have.filtering.done(function() {
			if(!item[self.eventNamespace]) item[self.eventNamespace] = {}; // do this earlier?
			var local = item[self.eventNamespace];
			self._each_allocated(function(item, m, d){
				delete item[self.eventNamespace].selected;
			});
			local.selected = true;
			self.options.on_needs_render();
		});
	},

	scroll: function(top) {
		var self = this, o = this.options;

		self._invalidate_positions();
		o.on_needs_render();
	},

	_update_groups: function() {
		var self = this, group, list = this.options.products;

		self.groups = [];
		for(var i=0;i<list.filtered.length;i++){
			var item = list.items[list.filtered[i]];
			var g = ((item.data.tags || [])['Product group'] || [])[0] || 'Other';
			if(g !== group){
				self.groups.push({name: group = g, i: i});
			}
		}
		//console.log('* _update_groups: groups=', self.groups.length, self.groups);

		this.groups_valid = true;
		self._positions_valid = false;
		return self.groups.length > 1;
	},

	_each_allocated: function(fn) {
		var self = this, o = self.options, list = o.products;

		self._positions_valid || self._calc_positions();

		for(var i=self._first;i<list.filtered.length;i++){
			var m = list.filtered[i];
			var item = list.items[list.filtered[i]];
			var local = item[self.eventNamespace];
			//if(!local.visible) console.log('each_allocated: range ', self._first, i, ' (' + (i - self._first) + ')');
			if(!local.visible) break;

			fn(item, m, i);
		}
	},

	// only results in viewport
	_results_by_group: function(fn1, fn2) {
		var self = this;

		self._positions_valid || self._calc_positions();

// TODO g may be incorrect if scrolling
		var g = -1, gr = {};
		this._each_allocated(function(item, m, d){
			var local = item[self.eventNamespace];
			var ig = local.ig;
			var group_name = ((item.data.tags && item.data.tags['Product group'] || [])[0]) || 'Other';
			if(g < 0 || (group_name && group_name !== gr.name)){
				g++;
				gr = $.findWhere(self.groups, {name: group_name});
				fn1(gr);
			}
			fn2(item, m, d, ig++, gr, g);
		});
	},

	_results_by_group_all: function(fn1, fn2, done) {
		var self = this, list = this.options.products;

		var g = -1, ig = 0, gr = {};
		for(var i=0;i<list.filtered.length;i++){
			var item = list.items[list.filtered[i]];
			var group_name = ((item.data.tags && item.data.tags['Product group'] || [])[0]) || 'Other';
			if(!i || (group_name !== gr.name)){
				g++;
				gr = $.findWhere(self.groups, {name: group_name});
				fn1(gr);
				ig = 0;
			}
			fn2(item, i, ig++, gr, g);
		};
		done && done(gr);
	},

	// return maximum number of items that can be shown when scrolled to top.
	max_items: function() {
		var self = this, list = this.options.products;
		var max = 0;

		if(this.cache.max_items) return this.cache.max_items;

		var y = 0;
		var gi = 0;
		list.each_by_facet('Product group',
			function(group){
				y += self.group_label_height;
				gi = 0;
			},
			function(item, i, ig){
				if(ig % self.n_columns === 0){
					y += self.item_height + self.padding.y;
				}
				if(y < self.cache.max_height){
					max = i + 1;
				}else{
					// TODO list.each_by_facet should respect return value of false
					return false;
				}
				gi++;
			}
		);

		return this.cache.max_items = max;
	},

	// return the height of all the filtered items
	natural_height: function() {
		var self = this;

		if(this.cache.natural_height) return this.cache.natural_height;
		this.groups_valid || this._update_groups();
		self._positions_valid || self._calc_positions();

		var h = 0;
		$.each(this.groups, function(i, gr) {
			if(gr.height) h += gr.height;
		});

		return this.cache.natural_height = h;
	},

	_new_element: function(d) {
		return {};
	}
});


return VGridGroupsView;

});
