/*
 *  TODO
 */
define(['jquery', 'ajax_queue', 'virtual-dom/h', 'chart-app/router'], function($, Ajaxqueue, h, page){

var instance = 0;
var show_title = true;
var img_data = {}

var VGridSimpleView = function(options){
	this.create(options)
}

// note: currently does not inherit from ViewBase
VGridSimpleView.prototype = {

	create: function(options) {
		this.options = $.extend({
			products: undefined,
			select: $.noop,
			scrollbar: null
		}, options);

		var self = this, o = this.options, el = $(o.renderer.root);

		this.eventNamespace = 'vgrid-' + (instance++);

		this.item_options = {
			on_click: function(item) {
				var selected = el.find('.selected');
				var widget = el.find('[name="' + item.name() + '"]').parents('.item');
				if(!widget.hasClass('selected')){
					self.select(item);
					o.select(item);
				}
				o.click(item);
			}
		},

		show_title && (this.item_options.show_title = true);

		o.renderer.on.render.once(function(){

			// TODO document why we are not binding to the thumbnail
			$(o.renderer.root).find('.outer').on('click mouseup', function(ev) {
				console.log('simple.click');
				var target = $(ev.target);

				var item = o.products.product_by_name(target.attr('name') || target.find('img.thumbnail-img').attr('name'));
				if(item){
					switch(ev.which){
						case undefined:
						case 1:
							return (ev.type === 'click') && self.item_options.on_click(item);
						case 2:
							ev.preventDefault();
							return o.middle_click(item);
					}
				}
			});
		});

		this.options.scrollbar.state.height = 0;
	},

	render: function() {
		var self = this, o = self.options;
		var inline_thumbnails = !!window.is_node;
		//console.log('%csimple.render', 'background-color:#ff9')

		o.products.cancel_thumbnails();

		this.groups_valid || this._update_groups();

		var group_label_height = (self.groups.length > 1) ? self.group_label_height : 0;

		items = [];
		self._results_by_group(
			function(group){
				if(self.groups.length > 1){
					items.push(h('h3.group-label', {
						onclick: function(e){
							page.add_state();
							facets = o.products.lookup_filter_by_name('facets')
							facets.set(['Product group', group.name], true)
							e.stopPropagation()
						}
					},
					[group.name]));
				}
			},
			function(item, m, d, ig, gr){
				var local = item[self.eventNamespace];

				var column = ig % self.n_columns;

				var url = img_data[item.name()] || item.data.thumbnail || item.cache.thumbnail.call(item); // cannot use the normal thumbnail method here because it is asynchronous

				items.push(h('div.item.thumbnail-wrapper' + (m === o.products.selection.value ? '.selected' : ''), [
					h('div.thumbnail', [
						h('img.thumbnail-img', {
							alt  : item.title_(),
							title: $('<div>').html(item.data.description).text() || item.title_(),
							name : item.name(),
							src  : (url && (url !== 'validation failed')) ? url : Ajaxqueue.options.host + '/backend/get-thumbnail/product/' + item.name() + '/',
							/*
							style: url
								? { visibility: 'visible', opacity: 1.0 }
								: { visibility: 'hidden', opacity: 0.0 },
							*/
							onclick: function() {
							}
						})
					]),
					h('div' + (show_title ? '.title' : '.hidden') + (item.has_widget('clickable') ? '.clickable' : ''), item.title_())
				]));

				inline_thumbnails && !url && item.thumbnail && item.thumbnail({tag: item.name() + self.eventNamespace}, function(url, image, error){
					if(!error){
						if(image){
							// we may have multiple callbacks from the same request, so img_data may already be set
// TODO why img_data? why not just use item.data.thumbnail ?
							img_data[item.name()] = image;
						}
						self.options.on_needs_render();
					}
				});
			}
		);

		return h('div.grid-items.thumbs.simple', {
			style: {height: '400px'},
			click: function(){
				console.log('simple.click');
				var target = $(ev.target);

				var item = o.products.product_by_name(target.attr('name') || target.find('img.thumbnail-img').attr('name'));
				self.item_options.on_click(item);
			}
		}, items);
	},

	select: function(item) {
		var self = this, o = this.options;

		o.products.have.filtering.done(function() {
			if(!item[self.eventNamespace]) item[self.eventNamespace] = {}; // do this earlier?
			var local = item[self.eventNamespace];
			self._each_allocated(function(item, m, d){
				if(item[self.eventNamespace]) delete item[self.eventNamespace].selected;
			});
			// TODO local.selected may not be needed - can use products.selected.value instead
			local.selected = true;
			self.options.on_needs_render();
		});
	},

	scroll_to: function() {
	},

	_update_groups: function() {
		var self = this, products = this.options.products, group;

		self.groups = [];
		for(var i=0;i<products.filtered.length;i++){
			var item = products.items[products.filtered[i]];
			var g = ((item.data.tags || [])['Product group'] || [])[0] || 'Other';
			if(g !== group){
				self.groups.push({name: group = g, i: i});
			}
		}
		//console.log('* _update_groups: groups=', self.groups.length, self.groups);

		this.groups_valid = true;
		self._positions_valid = false;
		return self.groups.length > 1;
	},

	_each_allocated: function(fn) {
		var self = this, products = self.options.products;

		for(var i=0;i<products.filtered.length;i++){
			var m = products.filtered[i];
			var item = products.items[products.filtered[i]];
			//var local = item[self.eventNamespace];
			//if(!local.visible) console.log('each_allocated: range ', self._first, i, ' (' + (i - self._first) + ')');

			fn(item, m, i);
		}
	},

	// only results in viewport
	_results_by_group: function(fn1, fn2) {
		var self = this;

		var g = -1, gr = {};
		this._each_allocated(function(item, m, d){
			//var local = item[self.eventNamespace];
			var ig = 0;//local.ig;
			var group_name = ((item.data.tags && item.data.tags['Product group'] || [])[0]) || 'Other';
			if(g < 0 || (group_name && group_name !== gr.name)){
				g++;
				gr = $.findWhere(self.groups, {name: group_name});
				fn1(gr);
			}
			fn2(item, m, d, ig++, gr, g);
		});
	},

	_results_by_group_all: function(fn1, fn2, done) {
		var self = this, list = this.options.products;
		var g = -1, ig = 0, gr = {};
		for(var i=0;i<list.filtered.length;i++){
			var item = list.items[list.filtered[i]];
			var group_name = ((item.data.tags && item.data.tags['Product group'] || [])[0]) || 'Other';
			if(!i || (group_name !== gr.name)){
				g++;
				gr = $.findWhere(self.groups, {name: group_name});
				fn1(gr);
				ig = 0;
			}
			fn2(item, i, ig++, gr, g);
		};
		done && done(gr);
	},

	resize: function() {
		// this view does not need any resizing
	},
}

return VGridSimpleView;

});
