
/*
 *   Base for a dialogue box that is controlled from the View menu and saves its state.
 *   TODO perhaps best as a wrapper rather than a base class, so that widgets can be optionally used without it.
 *        -change animation-controls to use the wrapper fn below.
 */
define(['jquery', 'bus', 'settings', 'jquery-ui/widget', 'element', 'light_dialogue'], function($, Bus, Settings) {

$.widget('ui.viewDialogue2', {

	options: {
		state: {},
		bus: Bus()
	},

	_create: function(){
		var self = this, o = this.options;

		o.bus.listen('menu-views-' + o.name + '-change', function (_, msg) {
			self.item.toggle();
		})
	},

	_init: function() {
		var self = this, o = this.options;

		self.item = self.element.div({className: o.name});

		self.item.lightDialogue($.extend({
				title: o.title,
				show_hide_menu: 'menu-views-' + o.name + '-change',
				name: o.name,
				dismiss: {
					message: 'do-menu-views-' + o.name + '-change',
					value: {
						value: false
					}
				}
			},
			o.state));

		if(!o.state.visible) self.item.hide();
	},

	destroy: function(){
		this.item.remove();
	}
});


$.viewDialogue = function(name, item) {
	var states = Settings.get('dialogue-states', {});
	var state = states[name] || {};
	var msg_name = 'menu-views-' + name + '-change';

	function open(_, msg){
		if(msg.value){
			Bus().forget(msg_name, open);
			state.visible = msg.value;

			$('#' + name)[item.widget || name](item.options).lightDialogue($.extend({
					title: item.title || '&nbsp;',
					show_hide_menu: msg_name,
					loader: true,
					name: name,
					dismiss: {
						message: 'do-' + msg_name,
						value: {
							value: false
						}
					}
				},
				state));
		}
	}

	Bus().listen(msg_name, open);

	state.visible && Bus().send(msg_name, {value: true});
};

});

