export function polyfill(main) {

	function loadScript(src, done) {
		var js = document.createElement('script');
		js.src = src;
		js.onload = done
		js.onerror = function() {
			done(new Error('Failed to load script ' + src));
		};
		document.head.appendChild(js);
	}

	function browserSupportsAllFeatures() {
		return window.Promise;
	}

	if (browserSupportsAllFeatures()) {
		main();
	} else {
		loadScript('/static/js/polyfills.js', main);
	}
}
