/*
 *  www_chart/canvas_renderer
 *
 *  This chart mixin overrides the default image display, instead using a canvas to reduce flicker.
 *
 *  TODO animation
 *  TODO where are controls ?
 *  TODO bail if browser doesnt support canvas
 */
define('www_chart/canvas_renderer', ['jquery'], function($) {

	return function(chart, o){
		var self = this;

		var img;
		var size = {width: 400, height: 300};

		// A backbuffer is used for performance but the improvement is not large.
		self.$canvas0 = $('<canvas>', {css: $.extend({overflow: 'hidden', position: 'absolute'}, size)});
		self.canvas0 = self.$canvas0[0];
		self.canvas0.width = size.width;
		self.canvas0.height = size.height;
		self.ctx0 = self.canvas0.getContext('2d');

		self.$canvas = chart.clip.canvas({className: 'chart-canvas'});//, css: $.extend({overflow: 'hidden', /*position: 'absolute', left: 100,*/ backgroundColor: '#fff'}, size)});
		self.canvas = self.$canvas[0];
		self.canvas.width = size.width;
		self.canvas.height = size.height;
		self.ctx = self.canvas.getContext('2d');
		self.ctx.clearRect(0, 0, size.width, size.height);
		self.ctx.globalAlpha = 1.0;

		self.ctx.push_state = function(fn) {
			var tmp = self.ctx.globalCompositeOperation;
			fn();
			self.ctx.globalCompositeOperation = tmp;
		}

		/*
		self.ctx0.clearRect(0, 0, size.width, size.height);
		self.ctx0.drawImage(chart.img[0], 0, 0, size.width, size.height);

		blit(0, 0);
		*/

		chart._render = function(url){

			img = new Image();
			img.onload = function() {
				setTimeout(function(){ // wait for product.update
					on_image_change(img);
				}, 0);
			}
			img.src = url;

			return chart;
		}

		this.destroy = function() {
		}

		function on_image_change(img) {
			if(img.width !== size.width || img.height !== size.height){
				size = {width: img.width, height: img.height};

				self.canvas0.width = size.width;
				self.canvas0.height = size.height;
				self.ctx0.globalCompositeOperation = 'copy';

				self.canvas.width = size.width;
				self.canvas.height = size.height;
				//self.$canvas.css(size);
				self.ctx.globalCompositeOperation = 'copy';

				$('#basic-chart').height(size.height);
			}

			self.ctx0.clearRect(0, 0, img.width, img.height);
			self.ctx0.drawImage(img, 0, 0, img.width, img.height);

			blit(0, 0);
		}

		function blit(x, y) {
			self.ctx.clearRect(0, 0, size.width, size.height);
			self.ctx.drawImage(self.canvas0, x, y);
		}
	}
});
