/*
 *  Parameter animator
 *
 *  Like ChartAnimator but can be used to animate any parameter.
 *
 */
define(function() {

	var state = {
		parameter: null
	}
	var chart;

	function ParameterAnimator() {
		this.chart =  function(_chart) {
			chart = _chart;
			return this;
		}

		this.parameter =  function(parameter) {
			state.parameter = parameter;
			return this;
		}

		this.getFrames = function() {
			return state.parameter.values;
		}

		this.showFrame = function(value) {
			chart.instance.set_parameter(state.parameter.name, value);
			return true;
		}

		this._on_start = function(ready_to_start) {
			ready_to_start();
		}

		this._on_stop = function() {
		}

		this._on_pause = function() {
		}

		this._on_resume = function() {
		}
	}
	ParameterAnimator.prototype = new $.AnimatorClient('parameter');

	return new ParameterAnimator();
});
